/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.SECTION;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                                case 0: state = State.SHEBANG; break;
                                case 4: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.SECTION; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.PRAGMA; break;
                                case 0: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.NORMAL; break;
                                case 7: state = State.NORMAL; break;
                                case 8: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA_CONTENT; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA_CONTENT; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA_PACKAGE_CONTENT; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA_PACKAGE_CONTENT; break;
                                case 8: state = State.PRAGMA_PACKAGE_CONTENT; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA_IGNORE; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 6: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 7: state = State.PRAGMA_CONTENT; break;
                                case 8: state = State.PRAGMA_PACKAGE_CONTENT; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 9: state = State.PRAGMA_IGNORE; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.COMMENT; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                                case 9: state = State.PRAGMA_IGNORE; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                                case 9: state = State.PRAGMA_IGNORE; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                                case 9: state = State.PRAGMA_IGNORE; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.MULTILINE_STRING_STATE; break;
                                case 0: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 246:
                        {
                              Token token = new246(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 247:
                        {
                              Token token = new247(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 248:
                        {
                              Token token = new248(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 249:
                        {
                              Token token = new249(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 250:
                        {
                              Token token = new250(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 251:
                        {
                              Token token = new251(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 252:
                        {
                              Token token = new252(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 253:
                        {
                              Token token = new253(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 254:
                        {
                              Token token = new254(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 255:
                        {
                              Token token = new255(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 256:
                        {
                              Token token = new256(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 257:
                        {
                              Token token = new257(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 258:
                        {
                              Token token = new258(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 259:
                        {
                              Token token = new259(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 260:
                        {
                              Token token = new260(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 261:
                        {
                              Token token = new261(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 262:
                        {
                              Token token = new262(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 263:
                        {
                              Token token = new263(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 264:
                        {
                              Token token = new264(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 265:
                        {
                              Token token = new265(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 266:
                        {
                              Token token = new266(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 267:
                        {
                              Token token = new267(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 268:
                        {
                              Token token = new268(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 269:
                        {
                              Token token = new269(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 270:
                        {
                              Token token = new270(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 271:
                        {
                              Token token = new271(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 272:
                        {
                              Token token = new272(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 273:
                        {
                              Token token = new273(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 274:
                        {
                              Token token = new274(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 275:
                        {
                              Token token = new275(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 276:
                        {
                              Token token = new276(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 277:
                        {
                              Token token = new277(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 278:
                        {
                              Token token = new278(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 279:
                        {
                              Token token = new279(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 280:
                        {
                              Token token = new280(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 281:
                        {
                              Token token = new281(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 282:
                        {
                              Token token = new282(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 283:
                        {
                              Token token = new283(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 284:
                        {
                              Token token = new284(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 285:
                        {
                              Token token = new285(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 286:
                        {
                              Token token = new286(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new4(  int line,   int pos) { return new TPragmaStart(line, pos); }
    Token new5(  int line,   int pos) { return new TPragmaEnd(line, pos); }
    Token new6(  int line,   int pos) { return new TPragmaGenerated(line, pos); }
    Token new7(  int line,   int pos) { return new TPragmaSymbolic(line, pos); }
    Token new8(  int line,   int pos) { return new TPragmaLabel(line, pos); }
    Token new9(  int line,   int pos) { return new TPragmaFile(line, pos); }
    Token new10(  int line,   int pos) { return new TPragmaPackage(line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TPragmaDescription(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TPragmaImportPackage(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TUnrecognisedPragma(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TPragmaFreeText(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TPragmaIdOrString(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TPragmaIgnoredText(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new20(  int line,   int pos) { return new TStar(line, pos); }
    Token new21(  int line,   int pos) { return new TSlash(line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TMultilineStringStart(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TMultilineStringEnd(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TMultilineStringContent(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new28(  int line,   int pos) { return new TDollar(line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new32(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new33(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new35(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new39(  int line,   int pos) { return new TComma(line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TInsertStartSequence(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TDot(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TDivision(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new51(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TRestrictHeadSequence(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TDoubleColon(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TAssign(text, line, pos); }
    Token new57(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TLess(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TLessGreater(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TInsertEndSequence(text, line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TOutputParameters(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new66(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new67(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new68(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TEqual(text, line, pos); }
    Token new71(  String text,   int line,   int pos) { return new TDoubleEqual(text, line, pos); }
    Token new72(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new73(  String text,   int line,   int pos) { return new TGreater(text, line, pos); }
    Token new74(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new75(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new76(  String text,   int line,   int pos) { return new TPartialBijection(text, line, pos); }
    Token new77(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new78(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new79(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new80(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new81(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new82(  int line,   int pos) { return new TAny(line, pos); }
    Token new83(  int line,   int pos) { return new TAssert(line, pos); }
    Token new84(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new85(  int line,   int pos) { return new TBe(line, pos); }
    Token new86(  int line,   int pos) { return new TBegin(line, pos); }
    Token new87(  int line,   int pos) { return new TBool(line, pos); }
    Token new88(  String text,   int line,   int pos) { return new TBfalse(text, line, pos); }
    Token new89(  int line,   int pos) { return new TCase(line, pos); }
    Token new90(  int line,   int pos) { return new TChoice(line, pos); }
    Token new91(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new92(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new93(  int line,   int pos) { return new TConstants(line, pos); }
    Token new94(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new95(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new96(  int line,   int pos) { return new TExpressions(line, pos); }
    Token new97(  int line,   int pos) { return new TPredicates(line, pos); }
    Token new98(  int line,   int pos) { return new TDo(line, pos); }
    Token new99(  int line,   int pos) { return new TEither(line, pos); }
    Token new100(  int line,   int pos) { return new TElse(line, pos); }
    Token new101(  int line,   int pos) { return new TElsif(line, pos); }
    Token new102(  int line,   int pos) { return new TEnd(line, pos); }
    Token new103(  int line,   int pos) { return new TExtends(line, pos); }
    Token new104(  int line,   int pos) { return new TFalse(line, pos); }
    Token new105(  int line,   int pos) { return new TFin(line, pos); }
    Token new106(  int line,   int pos) { return new TFin1(line, pos); }
    Token new107(  int line,   int pos) { return new TIf(line, pos); }
    Token new108(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new109(  int line,   int pos) { return new TImports(line, pos); }
    Token new110(  int line,   int pos) { return new TIn(line, pos); }
    Token new111(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new112(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new113(  int line,   int pos) { return new TInt(line, pos); }
    Token new114(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new115(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new116(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new117(  int line,   int pos) { return new TLet(line, pos); }
    Token new118(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new119(  int line,   int pos) { return new TMachine(line, pos); }
    Token new120(  int line,   int pos) { return new TModel(line, pos); }
    Token new121(  int line,   int pos) { return new TSystem(line, pos); }
    Token new122(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new123(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new124(  int line,   int pos) { return new TNat(line, pos); }
    Token new125(  int line,   int pos) { return new TNat1(line, pos); }
    Token new126(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new127(  String text,   int line,   int pos) { return new TNatural1(text, line, pos); }
    Token new128(  int line,   int pos) { return new TOf(line, pos); }
    Token new129(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new130(  int line,   int pos) { return new TOr(line, pos); }
    Token new131(  String text,   int line,   int pos) { return new TPi(text, line, pos); }
    Token new132(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new133(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new134(  int line,   int pos) { return new TPre(line, pos); }
    Token new135(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new136(  int line,   int pos) { return new TProperties(line, pos); }
    Token new137(  int line,   int pos) { return new TRefines(line, pos); }
    Token new138(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new139(  int line,   int pos) { return new TSees(line, pos); }
    Token new140(  int line,   int pos) { return new TSelect(line, pos); }
    Token new141(  int line,   int pos) { return new TSets(line, pos); }
    Token new142(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new143(  String text,   int line,   int pos) { return new TSigma(text, line, pos); }
    Token new144(  int line,   int pos) { return new TString(line, pos); }
    Token new145(  int line,   int pos) { return new TThen(line, pos); }
    Token new146(  int line,   int pos) { return new TTrue(line, pos); }
    Token new147(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new148(  int line,   int pos) { return new TUses(line, pos); }
    Token new149(  int line,   int pos) { return new TValue(line, pos); }
    Token new150(  int line,   int pos) { return new TVar(line, pos); }
    Token new151(  int line,   int pos) { return new TVariant(line, pos); }
    Token new152(  int line,   int pos) { return new TVariables(line, pos); }
    Token new153(  int line,   int pos) { return new TWhen(line, pos); }
    Token new154(  int line,   int pos) { return new TWhere(line, pos); }
    Token new155(  int line,   int pos) { return new TWhile(line, pos); }
    Token new156(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new157(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new158(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new159(  String text,   int line,   int pos) { return new TRestrictTailSequence(text, line, pos); }
    Token new160(  String text,   int line,   int pos) { return new TConcatSequence(text, line, pos); }
    Token new161(  int line,   int pos) { return new TArity(line, pos); }
    Token new162(  int line,   int pos) { return new TBin(line, pos); }
    Token new163(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new164(  int line,   int pos) { return new TBtree(line, pos); }
    Token new165(  int line,   int pos) { return new TCard(line, pos); }
    Token new166(  int line,   int pos) { return new TClosure(line, pos); }
    Token new167(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new168(  int line,   int pos) { return new TConc(line, pos); }
    Token new169(  int line,   int pos) { return new TConst(line, pos); }
    Token new170(  int line,   int pos) { return new TDom(line, pos); }
    Token new171(  int line,   int pos) { return new TFather(line, pos); }
    Token new172(  int line,   int pos) { return new TFirst(line, pos); }
    Token new173(  int line,   int pos) { return new TFnc(line, pos); }
    Token new174(  int line,   int pos) { return new TFront(line, pos); }
    Token new175(  int line,   int pos) { return new TId(line, pos); }
    Token new176(  int line,   int pos) { return new TInfix(line, pos); }
    Token new177(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new178(  int line,   int pos) { return new TIseq(line, pos); }
    Token new179(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new180(  int line,   int pos) { return new TIterate(line, pos); }
    Token new181(  int line,   int pos) { return new TLast(line, pos); }
    Token new182(  int line,   int pos) { return new TLeft(line, pos); }
    Token new183(  int line,   int pos) { return new TMax(line, pos); }
    Token new184(  int line,   int pos) { return new TMin(line, pos); }
    Token new185(  int line,   int pos) { return new TMirror(line, pos); }
    Token new186(  int line,   int pos) { return new TMod(line, pos); }
    Token new187(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new188(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new189(  int line,   int pos) { return new TPerm(line, pos); }
    Token new190(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new191(  int line,   int pos) { return new TPred(line, pos); }
    Token new192(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new193(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new194(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new195(  int line,   int pos) { return new TRank(line, pos); }
    Token new196(  int line,   int pos) { return new TRan(line, pos); }
    Token new197(  int line,   int pos) { return new TRec(line, pos); }
    Token new198(  int line,   int pos) { return new TRel(line, pos); }
    Token new199(  int line,   int pos) { return new TRev(line, pos); }
    Token new200(  int line,   int pos) { return new TRight(line, pos); }
    Token new201(  int line,   int pos) { return new TSeq(line, pos); }
    Token new202(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new203(  int line,   int pos) { return new TSizet(line, pos); }
    Token new204(  int line,   int pos) { return new TSize(line, pos); }
    Token new205(  int line,   int pos) { return new TSkip(line, pos); }
    Token new206(  int line,   int pos) { return new TSons(line, pos); }
    Token new207(  int line,   int pos) { return new TSon(line, pos); }
    Token new208(  int line,   int pos) { return new TStruct(line, pos); }
    Token new209(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new210(  int line,   int pos) { return new TSucc(line, pos); }
    Token new211(  int line,   int pos) { return new TTail(line, pos); }
    Token new212(  int line,   int pos) { return new TTop(line, pos); }
    Token new213(  int line,   int pos) { return new TTree(line, pos); }
    Token new214(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new215(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new216(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new217(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new218(  String text,   int line,   int pos) { return new TVerticalBar(text, line, pos); }
    Token new219(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new220(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new221(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new222(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new223(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new224(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new225(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new226(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new227(  int line,   int pos) { return new TKwFreetypes(line, pos); }
    Token new228(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new229(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new230(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new231(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new232(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new233(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new234(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new235(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new236(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new237(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new238(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new239(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new240(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new241(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new242(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new243(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new244(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new245(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new246(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new247(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new248(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new249(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new250(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new251(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new252(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new253(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new254(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new255(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new256(  int line,   int pos) { return new TKwMachineClause(line, pos); }
    Token new257(  String text,   int line,   int pos) { return new TTruthPredicate(text, line, pos); }
    Token new258(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new259(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new260(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new261(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new262(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new263(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new264(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new265(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new266(  int line,   int pos) { return new TKwRulesMachine(line, pos); }
    Token new267(  int line,   int pos) { return new TKwRule(line, pos); }
    Token new268(  String text,   int line,   int pos) { return new TKwSubstitutionOperator(text, line, pos); }
    Token new269(  String text,   int line,   int pos) { return new TKwPredicateOperator(text, line, pos); }
    Token new270(  String text,   int line,   int pos) { return new TKwExpressionOperator(text, line, pos); }
    Token new271(  String text,   int line,   int pos) { return new TKwPredicateAttribute(text, line, pos); }
    Token new272(  String text,   int line,   int pos) { return new TKwAttributeIdentifier(text, line, pos); }
    Token new273(  int line,   int pos) { return new TKwFor(line, pos); }
    Token new274(  int line,   int pos) { return new TKwRuleForAll(line, pos); }
    Token new275(  int line,   int pos) { return new TKwRuleFail(line, pos); }
    Token new276(  int line,   int pos) { return new TKwRuleErrorType(line, pos); }
    Token new277(  int line,   int pos) { return new TKwExpect(line, pos); }
    Token new278(  int line,   int pos) { return new TKwComputation(line, pos); }
    Token new279(  int line,   int pos) { return new TKwDefine(line, pos); }
    Token new280(  int line,   int pos) { return new TKwType(line, pos); }
    Token new281(  int line,   int pos) { return new TKwValue(line, pos); }
    Token new282(  int line,   int pos) { return new TKwBody(line, pos); }
    Token new283(  int line,   int pos) { return new TKwDummyValue(line, pos); }
    Token new284(  int line,   int pos) { return new TKwCounterexample(line, pos); }
    Token new285(  int line,   int pos) { return new TKwFunction(line, pos); }
    Token new286(  int line,   int pos) { return new TKwReferences(line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // SECTION
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 2}, {32, 32, 1}, {35, 35, 3}, {39, 39, 4}, {47, 47, 5}, {65, 67, 6}, {68, 68, 7}, {69, 72, 6}, {73, 73, 8}, {74, 76, 6}, {77, 77, 9}, {78, 81, 6}, {82, 82, 10}, {83, 83, 11}, {84, 90, 6}, {97, 122, 6}, {160, 160, 1}, {170, 170, 6}, {181, 181, 6}, {186, 186, 12}, {192, 214, 12}, {216, 246, 12}, {248, 501, 12}, {506, 535, 13}, {592, 680, 13}, {688, 696, 13}, {699, 705, 13}, {720, 721, 14}, {736, 740, 14}, {890, 890, 14}, {902, 902, 14}, {904, 906, 15}, {908, 908, 15}, {910, 929, 15}, {931, 974, 15}, {976, 982, 16}, {986, 986, 16}, {988, 988, 16}, {990, 990, 16}, {992, 992, 17}, {994, 1011, 17}, {1025, 1036, 17}, {1038, 1103, 17}, {1105, 1116, 18}, {1118, 1153, 18}, {1168, 1220, 18}, {1223, 1224, 18}, {1227, 1228, 19}, {1232, 1259, 19}, {1262, 1269, 19}, {1272, 1273, 19}, {1329, 1366, 20}, {1369, 1369, 20}, {1377, 1415, 20}, {1488, 1514, 20}, {1520, 1522, 21}, {1569, 1594, 21}, {1600, 1610, 21}, {1649, 1719, 21}, {1722, 1726, 22}, {1728, 1742, 22}, {1744, 1747, 22}, {1749, 1749, 22}, {1765, 1766, 23}, {2309, 2361, 23}, {2365, 2365, 23}, {2392, 2401, 23}, {2437, 2444, 24}, {2447, 2448, 24}, {2451, 2472, 24}, {2474, 2480, 24}, {2482, 2482, 25}, {2486, 2489, 25}, {2524, 2525, 25}, {2527, 2529, 25}, {2544, 2545, 26}, {2565, 2570, 26}, {2575, 2576, 26}, {2579, 2600, 26}, {2602, 2608, 27}, {2610, 2611, 27}, {2613, 2614, 27}, {2616, 2617, 27}, {2649, 2652, 28}, {2654, 2654, 28}, {2674, 2676, 28}, {2693, 2699, 28}, {2701, 2701, 29}, {2703, 2705, 29}, {2707, 2728, 29}, {2730, 2736, 29}, {2738, 2739, 30}, {2741, 2745, 30}, {2749, 2749, 30}, {2784, 2784, 30}, {2821, 2828, 31}, {2831, 2832, 31}, {2835, 2856, 31}, {2858, 2864, 31}, {2866, 2867, 32}, {2870, 2873, 32}, {2877, 2877, 32}, {2908, 2909, 32}, {2911, 2913, 33}, {2949, 2954, 33}, {2958, 2960, 33}, {2962, 2965, 33}, {2969, 2970, 34}, {2972, 2972, 34}, {2974, 2975, 34}, {2979, 2980, 34}, {2984, 2986, 35}, {2990, 2997, 35}, {2999, 3001, 35}, {3077, 3084, 35}, {3086, 3088, 36}, {3090, 3112, 36}, {3114, 3123, 36}, {3125, 3129, 36}, {3168, 3169, 37}, {3205, 3212, 37}, {3214, 3216, 37}, {3218, 3240, 37}, {3242, 3251, 38}, {3253, 3257, 38}, {3294, 3294, 38}, {3296, 3297, 38}, {3333, 3340, 39}, {3342, 3344, 39}, {3346, 3368, 39}, {3370, 3385, 39}, {3424, 3425, 40}, {3585, 3630, 40}, {3632, 3632, 40}, {3634, 3635, 40}, {3648, 3654, 41}, {3713, 3714, 41}, {3716, 3716, 41}, {3719, 3720, 41}, {3722, 3722, 42}, {3725, 3725, 42}, {3732, 3735, 42}, {3737, 3743, 42}, {3745, 3747, 43}, {3749, 3749, 43}, {3751, 3751, 43}, {3754, 3755, 43}, {3757, 3758, 44}, {3760, 3760, 44}, {3762, 3763, 44}, {3773, 3773, 44}, {3776, 3780, 45}, {3782, 3782, 45}, {3804, 3805, 45}, {3904, 3911, 45}, {3913, 3945, 46}, {4256, 4293, 46}, {4304, 4342, 46}, {4352, 4441, 46}, {4447, 4514, 47}, {4520, 4601, 47}, {7680, 7835, 47}, {7840, 7929, 47}, {7936, 7957, 48}, {7960, 7965, 48}, {7968, 8005, 48}, {8008, 8013, 48}, {8016, 8023, 49}, {8025, 8025, 49}, {8027, 8027, 49}, {8029, 8029, 49}, {8031, 8061, 50}, {8064, 8116, 50}, {8118, 8124, 50}, {8126, 8126, 50}, {8130, 8132, 51}, {8134, 8140, 51}, {8144, 8147, 51}, {8150, 8155, 51}, {8160, 8172, 52}, {8178, 8180, 52}, {8182, 8188, 52}, {8232, 8233, 1}, {8319, 8319, 52}, {8450, 8450, 53}, {8455, 8455, 53}, {8458, 8467, 53}, {8469, 8469, 53}, {8472, 8477, 54}, {8484, 8484, 54}, {8486, 8486, 54}, {8488, 8488, 54}, {8490, 8497, 55}, {8499, 8504, 55}, {12293, 12293, 55}, {12337, 12341, 55}, {12353, 12436, 56}, {12443, 12446, 56}, {12449, 12538, 56}, {12540, 12542, 56}, {12549, 12588, 57}, {12593, 12686, 57}, {19968, 40869, 57}, {44032, 55203, 57}, {63744, 64045, 58}, {64256, 64262, 58}, {64275, 64279, 58}, {64287, 64296, 58}, {64298, 64310, 59}, {64312, 64316, 59}, {64318, 64318, 59}, {64320, 64321, 59}, {64323, 64324, 60}, {64326, 64433, 60}, {64467, 64829, 60}, {64848, 64911, 60}, {64914, 64967, 61}, {65008, 65019, 61}, {65136, 65138, 61}, {65140, 65140, 61}, {65142, 65276, 62}, {65313, 65338, 62}, {65345, 65370, 62}, {65382, 65470, 62}, {65474, 65479, 63}, {65482, 65487, 63}, {65490, 65495, 63}, {65498, 65500, 63}, },
            {{9, 9, 1}, {32, 32, 1}, {160, 160, 1}, {8232, 8233, 1}, },
            {},
            {{33, 33, 64}, {65, 65, 65}, {67, 67, 66}, {68, 68, 67}, {69, 69, 68}, {70, 70, 69}, {73, 73, 70}, {76, 76, 71}, {77, 77, 72}, {79, 79, 73}, {80, 80, 74}, {83, 83, 75}, {85, 85, 76}, {86, 86, 77}, },
            {{39, 39, 78}, },
            {{42, 42, 79}, {47, 47, 80}, },
            {{48, 57, 81}, {65, 90, 82}, {95, 95, 83}, {97, 122, 82}, {170, 170, 82}, {181, 181, 82}, {186, 186, 84}, {192, 214, 84}, {216, 246, 84}, {248, 501, 84}, {506, 535, 85}, {592, 680, 85}, {688, 696, 85}, {699, 705, 85}, {720, 721, 86}, {736, 740, 86}, {890, 890, 86}, {902, 902, 86}, {904, 906, 87}, {908, 908, 87}, {910, 929, 87}, {931, 974, 87}, {976, 982, 88}, {986, 986, 88}, {988, 988, 88}, {990, 990, 88}, {992, 992, 89}, {994, 1011, 89}, {1025, 1036, 89}, {1038, 1103, 89}, {1105, 1116, 90}, {1118, 1153, 90}, {1168, 1220, 90}, {1223, 1224, 90}, {1227, 1228, 91}, {1232, 1259, 91}, {1262, 1269, 91}, {1272, 1273, 91}, {1329, 1366, 92}, {1369, 1369, 92}, {1377, 1415, 92}, {1488, 1514, 92}, {1520, 1522, 93}, {1569, 1594, 93}, {1600, 1610, 93}, {1649, 1719, 93}, {1722, 1726, 94}, {1728, 1742, 94}, {1744, 1747, 94}, {1749, 1749, 94}, {1765, 1766, 95}, {2309, 2361, 95}, {2365, 2365, 95}, {2392, 2401, 95}, {2437, 2444, 96}, {2447, 2448, 96}, {2451, 2472, 96}, {2474, 2480, 96}, {2482, 2482, 97}, {2486, 2489, 97}, {2524, 2525, 97}, {2527, 2529, 97}, {2544, 2545, 98}, {2565, 2570, 98}, {2575, 2576, 98}, {2579, 2600, 98}, {2602, 2608, 99}, {2610, 2611, 99}, {2613, 2614, 99}, {2616, 2617, 99}, {2649, 2652, 100}, {2654, 2654, 100}, {2674, 2676, 100}, {2693, 2699, 100}, {2701, 2701, 101}, {2703, 2705, 101}, {2707, 2728, 101}, {2730, 2736, 101}, {2738, 2739, 102}, {2741, 2745, 102}, {2749, 2749, 102}, {2784, 2784, 102}, {2821, 2828, 103}, {2831, 2832, 103}, {2835, 2856, 103}, {2858, 2864, 103}, {2866, 2867, 104}, {2870, 2873, 104}, {2877, 2877, 104}, {2908, 2909, 104}, {2911, 2913, 105}, {2949, 2954, 105}, {2958, 2960, 105}, {2962, 2965, 105}, {2969, 2970, 106}, {2972, 2972, 106}, {2974, 2975, 106}, {2979, 2980, 106}, {2984, 2986, 107}, {2990, 2997, 107}, {2999, 3001, 107}, {3077, 3084, 107}, {3086, 3088, 108}, {3090, 3112, 108}, {3114, 3123, 108}, {3125, 3129, 108}, {3168, 3169, 109}, {3205, 3212, 109}, {3214, 3216, 109}, {3218, 3240, 109}, {3242, 3251, 110}, {3253, 3257, 110}, {3294, 3294, 110}, {3296, 3297, 110}, {3333, 3340, 111}, {3342, 3344, 111}, {3346, 3368, 111}, {3370, 3385, 111}, {3424, 3425, 112}, {3585, 3630, 112}, {3632, 3632, 112}, {3634, 3635, 112}, {3648, 3654, 113}, {3713, 3714, 113}, {3716, 3716, 113}, {3719, 3720, 113}, {3722, 3722, 114}, {3725, 3725, 114}, {3732, 3735, 114}, {3737, 3743, 114}, {3745, 3747, 115}, {3749, 3749, 115}, {3751, 3751, 115}, {3754, 3755, 115}, {3757, 3758, 116}, {3760, 3760, 116}, {3762, 3763, 116}, {3773, 3773, 116}, {3776, 3780, 117}, {3782, 3782, 117}, {3804, 3805, 117}, {3904, 3911, 117}, {3913, 3945, 118}, {4256, 4293, 118}, {4304, 4342, 118}, {4352, 4441, 118}, {4447, 4514, 119}, {4520, 4601, 119}, {7680, 7835, 119}, {7840, 7929, 119}, {7936, 7957, 120}, {7960, 7965, 120}, {7968, 8005, 120}, {8008, 8013, 120}, {8016, 8023, 121}, {8025, 8025, 121}, {8027, 8027, 121}, {8029, 8029, 121}, {8031, 8061, 122}, {8064, 8116, 122}, {8118, 8124, 122}, {8126, 8126, 122}, {8130, 8132, 123}, {8134, 8140, 123}, {8144, 8147, 123}, {8150, 8155, 123}, {8160, 8172, 124}, {8178, 8180, 124}, {8182, 8188, 124}, {8319, 8319, 124}, {8450, 8450, 125}, {8455, 8455, 125}, {8458, 8467, 125}, {8469, 8469, 125}, {8472, 8477, 126}, {8484, 8484, 126}, {8486, 8486, 126}, {8488, 8488, 126}, {8490, 8497, 127}, {8499, 8504, 127}, {12293, 12293, 127}, {12337, 12341, 127}, {12353, 12436, 128}, {12443, 12446, 128}, {12449, 12538, 128}, {12540, 12542, 128}, {12549, 12588, 129}, {12593, 12686, 129}, {19968, 40869, 129}, {44032, 55203, 129}, {63744, 64045, 130}, {64256, 64262, 130}, {64275, 64279, 130}, {64287, 64296, 130}, {64298, 64310, 131}, {64312, 64316, 131}, {64318, 64318, 131}, {64320, 64321, 131}, {64323, 64324, 132}, {64326, 64433, 132}, {64467, 64829, 132}, {64848, 64911, 132}, {64914, 64967, 133}, {65008, 65019, 133}, {65136, 65138, 133}, {65140, 65140, 133}, {65142, 65276, 134}, {65313, 65338, 134}, {65345, 65370, 134}, {65382, 65470, 134}, {65474, 65479, 135}, {65482, 65487, 135}, {65490, 65495, 135}, {65498, 65500, 135}, },
            {{48, 57, 81}, {65, 68, 82}, {69, 69, 136}, {70, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 76, 82}, {77, 77, 137}, {78, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 65, 138}, {66, 78, 82}, {79, 79, 139}, {80, 90, 82}, {95, 65500, -8}, },
            {{48, 68, -9}, {69, 69, 140}, {70, 65500, -9}, },
            {{48, 57, 81}, {65, 88, 82}, {89, 89, 141}, {90, 90, 82}, {95, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {},
            {{66, 66, 142}, {83, 83, 143}, },
            {{79, 79, 144}, },
            {{69, 69, 145}, },
            {{88, 88, 146}, },
            {{79, 79, 147}, },
            {{77, 77, 148}, {78, 78, 149}, },
            {{79, 79, 150}, },
            {{65, 65, 151}, },
            {{80, 80, 152}, },
            {{82, 82, 153}, },
            {{69, 69, 154}, {85, 85, 155}, },
            {{83, 83, 156}, },
            {{65, 65, 157}, },
            {{39, 39, 158}, },
            {{64, 64, 159}, },
            {{0, 9, 160}, {10, 10, 161}, {11, 12, 160}, {13, 13, 161}, {14, 65535, 160}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 65500, -8}, },
            {{48, 57, 81}, {65, 69, 82}, {70, 70, 162}, {71, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 79, 82}, {80, 80, 163}, {81, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 66, 82}, {67, 67, 164}, {68, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 67, 82}, {68, 68, 165}, {69, 90, 82}, {95, 65500, -8}, },
            {{48, 69, -138}, {70, 70, 166}, {71, 65500, -138}, },
            {{48, 57, 81}, {65, 82, 82}, {83, 83, 167}, {84, 90, 82}, {95, 65500, -8}, },
            {{83, 83, 168}, },
            {{83, 83, 169}, },
            {{78, 78, 170}, },
            {{70, 70, 171}, },
            {{80, 80, 172}, {84, 84, 173}, },
            {{82, 82, 174}, },
            {{80, 80, 175}, },
            {{67, 67, 176}, {73, 73, 177}, {86, 86, 178}, },
            {{67, 67, 179}, },
            {{67, 67, 180}, },
            {{69, 69, 181}, {80, 80, 182}, },
            {{69, 69, 183}, {79, 79, 184}, },
            {{69, 69, 185}, {84, 84, 186}, },
            {{66, 66, 187}, },
            {{69, 69, 188}, },
            {{76, 76, 189}, {82, 82, 190}, },
            {},
            {},
            {{0, 65535, -82}, },
            {},
            {{48, 57, 81}, {65, 72, 82}, {73, 73, 191}, {74, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 75, 82}, {76, 76, 192}, {77, 90, 82}, {95, 65500, -8}, },
            {{48, 57, 81}, {65, 71, 82}, {72, 72, 193}, {73, 90, 82}, {95, 65500, -8}, },
            {{48, 68, -9}, {69, 69, 194}, {70, 65500, -9}, },
            {{48, 72, -164}, {73, 73, 195}, {74, 65500, -164}, },
            {{48, 57, 81}, {65, 83, 82}, {84, 84, 196}, {85, 90, 82}, {95, 65500, -8}, },
            {{84, 84, 197}, },
            {{69, 69, 198}, },
            {{67, 67, 199}, {83, 83, 200}, },
            {{73, 73, 201}, },
            {{82, 82, 202}, },
            {{69, 69, 203}, },
            {{77, 77, 204}, },
            {{79, 79, 205}, },
            {{76, 76, 206}, },
            {{84, 84, 207}, },
            {{65, 65, 208}, },
            {{65, 65, 209}, },
            {{72, 72, 210}, },
            {{82, 82, 211}, },
            {{65, 65, 212}, },
            {{68, 68, 213}, },
            {{77, 77, 214}, {80, 80, 215}, },
            {{83, 83, 216}, },
            {{83, 83, 217}, },
            {{83, 83, 218}, },
            {{83, 83, 219}, },
            {{85, 85, 220}, },
            {{73, 73, 221}, },
            {{48, 57, 81}, {65, 77, 82}, {78, 78, 222}, {79, 90, 82}, {95, 65500, -8}, },
            {{48, 68, -9}, {69, 69, 223}, {70, 65500, -9}, },
            {{48, 72, -164}, {73, 73, 224}, {74, 65500, -164}, },
            {{48, 75, -165}, {76, 76, 225}, {77, 65500, -165}, },
            {{48, 77, -193}, {78, 78, 226}, {79, 65500, -193}, },
            {{48, 68, -9}, {69, 69, 227}, {70, 65500, -9}, },
            {{82, 82, 228}, },
            {{82, 82, 229}, },
            {{82, 82, 230}, },
            {{84, 84, 231}, },
            {{78, 78, 232}, },
            {{69, 69, 233}, },
            {{78, 78, 234}, },
            {{85, 85, 235}, },
            {{82, 82, 236}, },
            {{85, 85, 237}, },
            {{73, 73, 238}, },
            {{82, 82, 239}, },
            {{76, 76, 240}, },
            {{73, 73, 241}, },
            {{65, 65, 242}, },
            {{84, 84, 243}, },
            {{73, 73, 244}, },
            {{79, 79, 245}, },
            {{69, 69, 246}, },
            {},
            {},
            {{84, 84, 247}, },
            {},
            {{69, 69, 248}, },
            {{65, 65, 249}, },
            {{48, 72, -164}, {73, 73, 250}, {74, 65500, -164}, },
            {{48, 76, -10}, {77, 77, 251}, {78, 65500, -10}, },
            {{48, 77, -193}, {78, 78, 252}, {79, 65500, -193}, },
            {{48, 65500, -8}, },
            {{48, 68, -9}, {69, 69, 253}, {70, 65500, -9}, },
            {{48, 76, -10}, {77, 77, 254}, {78, 65500, -10}, },
            {{65, 65, 255}, },
            {{84, 84, 256}, },
            {{69, 69, 257}, },
            {{65, 65, 258}, {82, 82, 259}, },
            {{73, 73, 260}, },
            {{83, 83, 261}, },
            {{68, 68, 262}, },
            {{76, 76, 263}, },
            {{84, 84, 264}, },
            {{68, 68, 265}, },
            {{65, 65, 266}, },
            {{73, 73, 267}, },
            {{95, 95, 268}, },
            {{78, 78, 269}, },
            {{84, 84, 270}, },
            {{84, 84, 271}, },
            {{67, 67, 272}, },
            {{84, 84, 273}, },
            {{82, 82, 274}, },
            {{73, 73, 275}, },
            {{83, 83, 276}, },
            {{66, 66, 277}, },
            {{48, 83, -169}, {84, 84, 278}, {85, 65500, -169}, },
            {{48, 68, -9}, {69, 69, 279}, {70, 65500, -9}, },
            {{48, 68, -9}, {69, 69, 280}, {70, 65500, -9}, },
            {{48, 76, -10}, {77, 77, 281}, {78, 65500, -10}, },
            {{48, 65500, -8}, },
            {{67, 67, 282}, },
            {{73, 73, 283}, },
            {{84, 84, 284}, },
            {{78, 78, 285}, },
            {{65, 65, 286}, },
            {{84, 84, 287}, },
            {{83, 83, 288}, },
            {{83, 83, 289}, },
            {{65, 65, 290}, },
            {{83, 83, 291}, },
            {{69, 69, 292}, },
            {{76, 76, 293}, },
            {{65, 65, 294}, },
            {{79, 79, 295}, },
            {{69, 69, 296}, },
            {{73, 73, 297}, },
            {{69, 69, 298}, },
            {{65, 65, 299}, },
            {{69, 69, 300}, },
            {{84, 84, 301}, },
            {{84, 84, 302}, },
            {},
            {{76, 76, 303}, },
            {{48, 72, -164}, {73, 73, 304}, {74, 65500, -164}, },
            {{48, 77, -193}, {78, 78, 305}, {79, 65500, -193}, },
            {{48, 65500, -8}, },
            {{48, 68, -9}, {69, 69, 306}, {70, 65500, -9}, },
            {{84, 84, 307}, },
            {{79, 79, 308}, },
            {{69, 69, 309}, },
            {{84, 84, 310}, },
            {{73, 73, 311}, },
            {{73, 73, 312}, },
            {{73, 73, 313}, },
            {},
            {},
            {},
            {{83, 83, 314}, },
            {{73, 73, 315}, },
            {{78, 78, 316}, },
            {{80, 80, 317}, },
            {{67, 67, 318}, },
            {{79, 79, 319}, },
            {{82, 82, 320}, },
            {{84, 84, 321}, },
            {{83, 83, 322}, },
            {{73, 73, 323}, },
            {{85, 85, 324}, },
            {{69, 69, 325}, },
            {{48, 57, 81}, {65, 78, 82}, {79, 79, 326}, {80, 65500, -11}, },
            {{48, 83, -169}, {84, 84, 327}, {85, 65500, -169}, },
            {{48, 77, -193}, {78, 78, 328}, {79, 65500, -193}, },
            {{95, 95, 329}, },
            {{78, 78, 330}, },
            {{95, 95, 331}, },
            {{83, 83, 332}, },
            {{78, 78, 333}, },
            {{79, 79, 334}, },
            {{79, 79, 335}, },
            {},
            {{83, 83, 336}, },
            {{84, 84, 337}, },
            {{69, 69, 338}, },
            {{76, 76, 339}, },
            {{78, 78, 340}, },
            {{78, 78, 341}, },
            {{69, 69, 342}, },
            {},
            {{69, 69, 343}, },
            {{84, 84, 344}, },
            {{83, 83, 345}, },
            {{48, 77, -193}, {78, 78, 346}, {79, 65500, -193}, },
            {{48, 57, 81}, {65, 65, 347}, {66, 90, 82}, {95, 65500, -8}, },
            {{48, 83, -169}, {84, 84, 348}, {85, 65500, -169}, },
            {{67, 67, 349}, {86, 86, 350}, },
            {{83, 83, 351}, },
            {{67, 67, 352}, {86, 86, 353}, },
            {},
            {{84, 84, 354}, },
            {{78, 78, 355}, },
            {{78, 78, 356}, },
            {{65, 65, 357}, },
            {},
            {{82, 82, 358}, },
            {{65, 65, 359}, },
            {{83, 83, 360}, },
            {},
            {},
            {{83, 83, 361}, },
            {{73, 73, 362}, },
            {},
            {{48, 82, -143}, {83, 83, 363}, {84, 65500, -143}, },
            {{48, 83, -169}, {84, 84, 364}, {85, 65500, -169}, },
            {{48, 65500, -8}, },
            {{79, 79, 365}, },
            {{65, 65, 366}, },
            {},
            {{79, 79, 367}, },
            {{65, 65, 368}, },
            {{83, 83, 369}, },
            {{83, 83, 370}, },
            {},
            {{84, 84, 371}, },
            {{65, 65, 372}, },
            {{85, 85, 373}, },
            {},
            {},
            {{79, 79, 374}, },
            {{48, 65500, -8}, },
            {{48, 72, -164}, {73, 73, 375}, {74, 65500, -164}, },
            {{78, 78, 376}, },
            {{82, 82, 377}, },
            {{78, 78, 378}, },
            {{82, 82, 379}, },
            {},
            {},
            {{73, 73, 380}, },
            {{84, 84, 381}, },
            {{83, 83, 382}, },
            {{78, 78, 383}, },
            {{48, 78, -306}, {79, 79, 384}, {80, 65500, -11}, },
            {{83, 83, 385}, },
            {{73, 73, 386}, },
            {{83, 83, 387}, },
            {{73, 73, 388}, },
            {{79, 79, 389}, },
            {{73, 73, 390}, },
            {{69, 69, 391}, },
            {},
            {{48, 77, -193}, {78, 78, 392}, {79, 65500, -193}, },
            {{84, 84, 393}, },
            {{65, 65, 394}, },
            {{84, 84, 395}, },
            {{65, 65, 396}, },
            {{78, 78, 397}, },
            {{79, 79, 398}, },
            {},
            {{48, 65500, -8}, },
            {{65, 65, 399}, },
            {{66, 66, 400}, },
            {{65, 65, 401}, },
            {{66, 66, 402}, },
            {},
            {{78, 78, 403}, },
            {{78, 78, 404}, },
            {{76, 76, 405}, },
            {{78, 78, 406}, },
            {{76, 76, 407}, },
            {{83, 83, 408}, },
            {{84, 84, 409}, },
            {{69, 69, 410}, },
            {{84, 84, 411}, },
            {{69, 69, 412}, },
            {},
            {{83, 83, 413}, },
            {{83, 83, 414}, },
            {{83, 83, 415}, },
            {{83, 83, 416}, },
            {},
            {},
            {},
            {},
        }
        { // NORMAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 2}, {32, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {64, 64, 25}, {65, 65, 26}, {66, 66, 27}, {67, 67, 28}, {68, 68, 29}, {69, 69, 30}, {70, 70, 31}, {71, 72, 32}, {73, 73, 33}, {74, 75, 32}, {76, 76, 34}, {77, 77, 35}, {78, 78, 36}, {79, 79, 37}, {80, 80, 38}, {81, 81, 32}, {82, 82, 39}, {83, 83, 40}, {84, 84, 41}, {85, 85, 42}, {86, 86, 43}, {87, 87, 44}, {88, 90, 32}, {91, 91, 45}, {92, 92, 46}, {93, 93, 47}, {94, 94, 48}, {95, 95, 49}, {97, 97, 50}, {98, 98, 51}, {99, 99, 52}, {100, 100, 53}, {101, 101, 32}, {102, 102, 54}, {103, 104, 32}, {105, 105, 55}, {106, 107, 32}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 32}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 32}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {160, 160, 1}, {170, 170, 32}, {172, 172, 69}, {181, 181, 32}, {183, 183, 70}, {186, 186, 71}, {192, 214, 71}, {215, 215, 72}, {216, 246, 71}, {247, 247, 73}, {248, 501, 71}, {506, 535, 74}, {592, 680, 74}, {688, 696, 74}, {699, 705, 74}, {720, 721, 75}, {736, 740, 75}, {890, 890, 75}, {902, 902, 75}, {904, 906, 76}, {908, 908, 76}, {910, 929, 76}, {931, 954, 76}, {955, 955, 77}, {956, 974, 76}, {976, 982, 78}, {986, 986, 78}, {988, 988, 78}, {990, 990, 78}, {992, 992, 79}, {994, 1011, 79}, {1025, 1036, 79}, {1038, 1103, 79}, {1105, 1116, 80}, {1118, 1153, 80}, {1168, 1220, 80}, {1223, 1224, 80}, {1227, 1228, 81}, {1232, 1259, 81}, {1262, 1269, 81}, {1272, 1273, 81}, {1329, 1366, 82}, {1369, 1369, 82}, {1377, 1415, 82}, {1488, 1514, 82}, {1520, 1522, 83}, {1569, 1594, 83}, {1600, 1610, 83}, {1649, 1719, 83}, {1722, 1726, 84}, {1728, 1742, 84}, {1744, 1747, 84}, {1749, 1749, 84}, {1765, 1766, 85}, {2309, 2361, 85}, {2365, 2365, 85}, {2392, 2401, 85}, {2437, 2444, 86}, {2447, 2448, 86}, {2451, 2472, 86}, {2474, 2480, 86}, {2482, 2482, 87}, {2486, 2489, 87}, {2524, 2525, 87}, {2527, 2529, 87}, {2544, 2545, 88}, {2565, 2570, 88}, {2575, 2576, 88}, {2579, 2600, 88}, {2602, 2608, 89}, {2610, 2611, 89}, {2613, 2614, 89}, {2616, 2617, 89}, {2649, 2652, 90}, {2654, 2654, 90}, {2674, 2676, 90}, {2693, 2699, 90}, {2701, 2701, 91}, {2703, 2705, 91}, {2707, 2728, 91}, {2730, 2736, 91}, {2738, 2739, 92}, {2741, 2745, 92}, {2749, 2749, 92}, {2784, 2784, 92}, {2821, 2828, 93}, {2831, 2832, 93}, {2835, 2856, 93}, {2858, 2864, 93}, {2866, 2867, 94}, {2870, 2873, 94}, {2877, 2877, 94}, {2908, 2909, 94}, {2911, 2913, 95}, {2949, 2954, 95}, {2958, 2960, 95}, {2962, 2965, 95}, {2969, 2970, 96}, {2972, 2972, 96}, {2974, 2975, 96}, {2979, 2980, 96}, {2984, 2986, 97}, {2990, 2997, 97}, {2999, 3001, 97}, {3077, 3084, 97}, {3086, 3088, 98}, {3090, 3112, 98}, {3114, 3123, 98}, {3125, 3129, 98}, {3168, 3169, 99}, {3205, 3212, 99}, {3214, 3216, 99}, {3218, 3240, 99}, {3242, 3251, 100}, {3253, 3257, 100}, {3294, 3294, 100}, {3296, 3297, 100}, {3333, 3340, 101}, {3342, 3344, 101}, {3346, 3368, 101}, {3370, 3385, 101}, {3424, 3425, 102}, {3585, 3630, 102}, {3632, 3632, 102}, {3634, 3635, 102}, {3648, 3654, 103}, {3713, 3714, 103}, {3716, 3716, 103}, {3719, 3720, 103}, {3722, 3722, 104}, {3725, 3725, 104}, {3732, 3735, 104}, {3737, 3743, 104}, {3745, 3747, 105}, {3749, 3749, 105}, {3751, 3751, 105}, {3754, 3755, 105}, {3757, 3758, 106}, {3760, 3760, 106}, {3762, 3763, 106}, {3773, 3773, 106}, {3776, 3780, 107}, {3782, 3782, 107}, {3804, 3805, 107}, {3904, 3911, 107}, {3913, 3945, 108}, {4256, 4293, 108}, {4304, 4342, 108}, {4352, 4441, 108}, {4447, 4514, 109}, {4520, 4601, 109}, {7680, 7835, 109}, {7840, 7929, 109}, {7936, 7957, 110}, {7960, 7965, 110}, {7968, 8005, 110}, {8008, 8013, 110}, {8016, 8023, 111}, {8025, 8025, 111}, {8027, 8027, 111}, {8029, 8029, 111}, {8031, 8061, 112}, {8064, 8116, 112}, {8118, 8124, 112}, {8126, 8126, 112}, {8130, 8132, 113}, {8134, 8140, 113}, {8144, 8147, 113}, {8150, 8155, 113}, {8160, 8172, 114}, {8178, 8180, 114}, {8182, 8188, 114}, {8229, 8229, 115}, {8232, 8233, 1}, {8315, 8315, 116}, {8319, 8319, 114}, {8450, 8450, 117}, {8455, 8455, 117}, {8458, 8467, 117}, {8469, 8469, 118}, {8472, 8472, 119}, {8473, 8473, 120}, {8474, 8477, 119}, {8484, 8484, 121}, {8486, 8486, 119}, {8488, 8488, 119}, {8490, 8497, 122}, {8499, 8504, 122}, {8592, 8592, 123}, {8593, 8593, 124}, {8594, 8594, 125}, {8595, 8595, 126}, {8596, 8596, 127}, {8608, 8608, 128}, {8611, 8611, 129}, {8614, 8614, 130}, {8658, 8658, 131}, {8660, 8660, 132}, {8696, 8696, 133}, {8701, 8701, 134}, {8702, 8702, 135}, {8704, 8704, 136}, {8707, 8707, 137}, {8709, 8709, 138}, {8712, 8712, 139}, {8713, 8713, 140}, {8719, 8719, 141}, {8721, 8721, 142}, {8722, 8722, 143}, {8739, 8739, 144}, {8741, 8741, 145}, {8743, 8743, 146}, {8744, 8744, 147}, {8745, 8745, 148}, {8746, 8746, 149}, {8764, 8764, 150}, {8800, 8800, 151}, {8804, 8804, 152}, {8805, 8805, 153}, {8834, 8834, 154}, {8836, 8836, 155}, {8838, 8838, 156}, {8840, 8840, 157}, {8855, 8855, 158}, {8868, 8868, 159}, {8869, 8869, 160}, {8898, 8898, 161}, {8899, 8899, 162}, {8918, 8918, 163}, {8978, 8978, 164}, {9654, 9654, 165}, {9655, 9655, 166}, {9664, 9664, 167}, {9665, 9665, 168}, {10496, 10496, 169}, {10516, 10516, 170}, {10518, 10518, 171}, {10852, 10852, 172}, {10853, 10853, 173}, {12293, 12293, 122}, {12337, 12341, 122}, {12353, 12436, 174}, {12443, 12446, 174}, {12449, 12538, 174}, {12540, 12542, 174}, {12549, 12588, 175}, {12593, 12686, 175}, {19968, 40869, 175}, {44032, 55203, 175}, {57600, 57600, 176}, {57601, 57601, 177}, {57602, 57602, 178}, {57603, 57603, 179}, {63744, 64045, 180}, {64256, 64262, 180}, {64275, 64279, 180}, {64287, 64296, 180}, {64298, 64310, 181}, {64312, 64316, 181}, {64318, 64318, 181}, {64320, 64321, 181}, {64323, 64324, 182}, {64326, 64433, 182}, {64467, 64829, 182}, {64848, 64911, 182}, {64914, 64967, 183}, {65008, 65019, 183}, {65136, 65138, 183}, {65140, 65140, 183}, {65142, 65276, 184}, {65313, 65338, 184}, {65345, 65370, 184}, {65382, 65470, 184}, {65474, 65479, 185}, {65482, 65487, 185}, {65490, 65495, 185}, {65498, 65500, 185}, },
            {{9, 9, 1}, {32, 32, 1}, {160, 160, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 9, 186}, {11, 12, 186}, {14, 33, 186}, {34, 34, 187}, {35, 91, 186}, {92, 92, 188}, {93, 65535, 186}, },
            {{33, 33, 189}, },
            {},
            {},
            {},
            {{39, 39, 190}, },
            {},
            {},
            {{42, 42, 191}, },
            {{45, 45, 192}, {8722, 8722, 193}, },
            {},
            {{45, 45, 194}, {62, 62, 195}, {8722, 8722, 196}, },
            {{46, 46, 197}, },
            {{42, 42, 198}, {47, 47, 199}, {58, 58, 200}, {60, 60, 201}, {61, 61, 202}, {92, 92, 203}, {124, 124, 204}, },
            {{48, 57, 19}, {120, 120, 205}, },
            {{48, 57, 19}, },
            {{58, 58, 206}, {61, 61, 207}, {8712, 8712, 208}, },
            {},
            {{9, 9, 209}, {10, 10, 210}, {13, 13, 210}, {32, 32, 209}, {43, 43, 211}, {45, 45, 212}, {58, 58, 213}, {60, 60, 214}, {61, 61, 215}, {62, 62, 216}, {124, 124, 217}, {160, 160, 209}, {8232, 8233, 209}, {8722, 8722, 218}, },
            {{61, 61, 219}, {62, 62, 220}, },
            {{43, 43, 221}, {45, 45, 222}, {60, 60, 223}, {61, 61, 224}, {8722, 8722, 225}, },
            {{35, 35, 226}, },
            {{48, 57, 227}, {65, 65, 228}, {66, 66, 229}, {67, 77, 228}, {78, 78, 230}, {79, 82, 228}, {83, 83, 231}, {84, 90, 228}, {95, 95, 232}, {97, 122, 228}, {170, 170, 228}, {181, 181, 228}, {186, 186, 233}, {192, 214, 233}, {216, 246, 233}, {248, 501, 233}, {506, 535, 234}, {592, 680, 234}, {688, 696, 234}, {699, 705, 234}, {720, 721, 235}, {736, 740, 235}, {890, 890, 235}, {902, 902, 235}, {904, 906, 236}, {908, 908, 236}, {910, 929, 236}, {931, 974, 236}, {976, 982, 237}, {986, 986, 237}, {988, 988, 237}, {990, 990, 237}, {992, 992, 238}, {994, 1011, 238}, {1025, 1036, 238}, {1038, 1103, 238}, {1105, 1116, 239}, {1118, 1153, 239}, {1168, 1220, 239}, {1223, 1224, 239}, {1227, 1228, 240}, {1232, 1259, 240}, {1262, 1269, 240}, {1272, 1273, 240}, {1329, 1366, 241}, {1369, 1369, 241}, {1377, 1415, 241}, {1488, 1514, 241}, {1520, 1522, 242}, {1569, 1594, 242}, {1600, 1610, 242}, {1649, 1719, 242}, {1722, 1726, 243}, {1728, 1742, 243}, {1744, 1747, 243}, {1749, 1749, 243}, {1765, 1766, 244}, {2309, 2361, 244}, {2365, 2365, 244}, {2392, 2401, 244}, {2437, 2444, 245}, {2447, 2448, 245}, {2451, 2472, 245}, {2474, 2480, 245}, {2482, 2482, 246}, {2486, 2489, 246}, {2524, 2525, 246}, {2527, 2529, 246}, {2544, 2545, 247}, {2565, 2570, 247}, {2575, 2576, 247}, {2579, 2600, 247}, {2602, 2608, 248}, {2610, 2611, 248}, {2613, 2614, 248}, {2616, 2617, 248}, {2649, 2652, 249}, {2654, 2654, 249}, {2674, 2676, 249}, {2693, 2699, 249}, {2701, 2701, 250}, {2703, 2705, 250}, {2707, 2728, 250}, {2730, 2736, 250}, {2738, 2739, 251}, {2741, 2745, 251}, {2749, 2749, 251}, {2784, 2784, 251}, {2821, 2828, 252}, {2831, 2832, 252}, {2835, 2856, 252}, {2858, 2864, 252}, {2866, 2867, 253}, {2870, 2873, 253}, {2877, 2877, 253}, {2908, 2909, 253}, {2911, 2913, 254}, {2949, 2954, 254}, {2958, 2960, 254}, {2962, 2965, 254}, {2969, 2970, 255}, {2972, 2972, 255}, {2974, 2975, 255}, {2979, 2980, 255}, {2984, 2986, 256}, {2990, 2997, 256}, {2999, 3001, 256}, {3077, 3084, 256}, {3086, 3088, 257}, {3090, 3112, 257}, {3114, 3123, 257}, {3125, 3129, 257}, {3168, 3169, 258}, {3205, 3212, 258}, {3214, 3216, 258}, {3218, 3240, 258}, {3242, 3251, 259}, {3253, 3257, 259}, {3294, 3294, 259}, {3296, 3297, 259}, {3333, 3340, 260}, {3342, 3344, 260}, {3346, 3368, 260}, {3370, 3385, 260}, {3424, 3425, 261}, {3585, 3630, 261}, {3632, 3632, 261}, {3634, 3635, 261}, {3648, 3654, 262}, {3713, 3714, 262}, {3716, 3716, 262}, {3719, 3720, 262}, {3722, 3722, 263}, {3725, 3725, 263}, {3732, 3735, 263}, {3737, 3743, 263}, {3745, 3747, 264}, {3749, 3749, 264}, {3751, 3751, 264}, {3754, 3755, 264}, {3757, 3758, 265}, {3760, 3760, 265}, {3762, 3763, 265}, {3773, 3773, 265}, {3776, 3780, 266}, {3782, 3782, 266}, {3804, 3805, 266}, {3904, 3911, 266}, {3913, 3945, 267}, {4256, 4293, 267}, {4304, 4342, 267}, {4352, 4441, 267}, {4447, 4514, 268}, {4520, 4601, 268}, {7680, 7835, 268}, {7840, 7929, 268}, {7936, 7957, 269}, {7960, 7965, 269}, {7968, 8005, 269}, {8008, 8013, 269}, {8016, 8023, 270}, {8025, 8025, 270}, {8027, 8027, 270}, {8029, 8029, 270}, {8031, 8061, 271}, {8064, 8116, 271}, {8118, 8124, 271}, {8126, 8126, 271}, {8130, 8132, 272}, {8134, 8140, 272}, {8144, 8147, 272}, {8150, 8155, 272}, {8160, 8172, 273}, {8178, 8180, 273}, {8182, 8188, 273}, {8319, 8319, 273}, {8450, 8450, 274}, {8455, 8455, 274}, {8458, 8467, 274}, {8469, 8469, 274}, {8472, 8477, 275}, {8484, 8484, 275}, {8486, 8486, 275}, {8488, 8488, 275}, {8490, 8497, 276}, {8499, 8504, 276}, {12293, 12293, 276}, {12337, 12341, 276}, {12353, 12436, 277}, {12443, 12446, 277}, {12449, 12538, 277}, {12540, 12542, 277}, {12549, 12588, 278}, {12593, 12686, 278}, {19968, 40869, 278}, {44032, 55203, 278}, {63744, 64045, 279}, {64256, 64262, 279}, {64275, 64279, 279}, {64287, 64296, 279}, {64298, 64310, 280}, {64312, 64316, 280}, {64318, 64318, 280}, {64320, 64321, 280}, {64323, 64324, 281}, {64326, 64433, 281}, {64467, 64829, 281}, {64848, 64911, 281}, {64914, 64967, 282}, {65008, 65019, 282}, {65136, 65138, 282}, {65140, 65140, 282}, {65142, 65276, 283}, {65313, 65338, 283}, {65345, 65370, 283}, {65382, 65470, 283}, {65474, 65479, 284}, {65482, 65487, 284}, {65490, 65495, 284}, {65498, 65500, 284}, },
            {{48, 57, 227}, {65, 68, 228}, {69, 69, 285}, {70, 78, 228}, {79, 79, 286}, {80, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 65, 287}, {66, 71, 228}, {72, 72, 288}, {73, 78, 228}, {79, 79, 289}, {80, 65500, -29}, },
            {{48, 68, -29}, {69, 69, 290}, {70, 78, 228}, {79, 79, 291}, {80, 84, 228}, {85, 85, 292}, {86, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 72, 228}, {73, 73, 293}, {74, 75, 228}, {76, 76, 294}, {77, 77, 228}, {78, 78, 295}, {79, 81, 228}, {82, 82, 296}, {83, 85, 228}, {86, 86, 297}, {87, 87, 228}, {88, 88, 298}, {89, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 65, 299}, {66, 72, 228}, {73, 73, 300}, {74, 78, 228}, {79, 79, 301}, {80, 81, 228}, {82, 82, 302}, {83, 84, 228}, {85, 85, 303}, {86, 65500, -31}, },
            {{48, 57, 227}, {65, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 69, 228}, {70, 70, 304}, {71, 76, 228}, {77, 77, 305}, {78, 78, 306}, {79, 90, 228}, {95, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 307}, {70, 78, 228}, {79, 79, 308}, {80, 65500, -29}, },
            {{48, 57, 227}, {65, 65, 309}, {66, 72, 228}, {73, 73, 310}, {74, 78, 228}, {79, 79, 311}, {80, 65500, -29}, },
            {{48, 57, 227}, {65, 65, 312}, {66, 90, 228}, {95, 65500, -28}, },
            {{48, 69, -35}, {70, 70, 313}, {71, 79, 228}, {80, 80, 314}, {81, 81, 228}, {82, 82, 315}, {83, 90, 228}, {95, 65500, -28}, },
            {{48, 72, -32}, {73, 73, 316}, {74, 78, 228}, {79, 79, 317}, {80, 81, 228}, {82, 82, 318}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 319}, {70, 84, 228}, {85, 85, 320}, {86, 65500, -31}, },
            {{48, 68, -29}, {69, 69, 321}, {70, 72, 228}, {73, 73, 322}, {74, 83, 228}, {84, 84, 323}, {85, 88, 228}, {89, 89, 324}, {90, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 71, 228}, {72, 72, 325}, {73, 81, 228}, {82, 82, 326}, {83, 88, 228}, {89, 89, 327}, {90, 65500, -42}, },
            {{48, 57, 227}, {65, 77, 228}, {78, 78, 328}, {79, 82, 228}, {83, 83, 329}, {84, 65500, -28}, },
            {{48, 57, 227}, {65, 65, 330}, {66, 65500, -38}, },
            {{48, 71, -43}, {72, 72, 331}, {73, 90, 228}, {95, 65500, -28}, },
            {},
            {{47, 47, 332}, {124, 124, 333}, },
            {},
            {},
            {},
            {{48, 95, -34}, {97, 113, 228}, {114, 114, 334}, {115, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 101, 228}, {102, 102, 335}, {103, 104, 228}, {105, 105, 336}, {106, 110, 228}, {111, 111, 337}, {112, 115, 228}, {116, 116, 338}, {117, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 97, 339}, {98, 107, 228}, {108, 108, 340}, {109, 110, 228}, {111, 111, 341}, {112, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 110, 228}, {111, 111, 342}, {112, 65500, -54}, },
            {{48, 95, -34}, {97, 97, 343}, {98, 104, 228}, {105, 105, 344}, {106, 109, 228}, {110, 110, 345}, {111, 113, 228}, {114, 114, 346}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 99, 228}, {100, 100, 347}, {101, 109, 228}, {110, 110, 348}, {111, 114, 228}, {115, 115, 349}, {116, 116, 350}, {117, 65500, -53}, },
            {{48, 95, -34}, {97, 97, 351}, {98, 100, 228}, {101, 101, 352}, {102, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 97, 353}, {98, 104, 228}, {105, 105, 354}, {106, 110, 228}, {111, 111, 355}, {112, 65500, -54}, },
            {{48, 110, -55}, {111, 111, 356}, {112, 65500, -54}, },
            {{48, 113, -52}, {114, 114, 357}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 100, 228}, {101, 101, 358}, {102, 110, 228}, {111, 111, 359}, {112, 113, 228}, {114, 114, 360}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 97, 361}, {98, 100, 228}, {101, 101, 362}, {102, 104, 228}, {105, 105, 363}, {106, 122, 228}, {170, 65500, -28}, },
            {{48, 100, -62}, {101, 101, 364}, {102, 104, 228}, {105, 105, 365}, {106, 106, 228}, {107, 107, 366}, {108, 110, 228}, {111, 111, 367}, {112, 115, 228}, {116, 116, 368}, {117, 117, 369}, {118, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 97, 370}, {98, 110, 228}, {111, 111, 371}, {112, 113, 228}, {114, 114, 372}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 109, 228}, {110, 110, 373}, {111, 122, 228}, {170, 65500, -28}, },
            {},
            {{45, 45, 374}, {62, 62, 375}, {124, 124, 376}, },
            {},
            {},
            {},
            {},
            {{48, 65500, -34}, },
            {},
            {},
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {},
            {{185, 185, 377}, },
            {{48, 65500, -34}, },
            {{48, 48, 227}, {49, 49, 378}, {50, 57, 227}, {65, 8319, -34}, {8321, 8321, 379}, {8450, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 48, 227}, {49, 49, 380}, {50, 8319, -120}, {8321, 8321, 381}, {8450, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{45, 8722, -17}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {},
            {},
            {},
            {},
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{0, 65535, -6}, },
            {},
            {{0, 9, 382}, {11, 12, 382}, {14, 65535, 382}, },
            {},
            {{39, 39, 383}, },
            {},
            {{62, 62, 384}, },
            {{62, 62, 384}, },
            {{62, 62, 385}, },
            {},
            {{62, 62, 385}, },
            {},
            {{64, 64, 386}, },
            {{0, 9, 387}, {10, 10, 388}, {11, 12, 387}, {13, 13, 388}, {14, 65535, 387}, },
            {},
            {{58, 58, 389}, {60, 60, 390}, },
            {},
            {},
            {{92, 92, 391}, },
            {{48, 57, 392}, {65, 70, 392}, {97, 102, 392}, },
            {},
            {},
            {},
            {{9, 32, -24}, {62, 62, 216}, {160, 8233, -24}, },
            {{9, 8233, -211}, },
            {},
            {{45, 45, 393}, {62, 62, 394}, },
            {},
            {{45, 45, 395}, {58, 58, 396}, {124, 124, 397}, {8722, 8722, 398}, },
            {{62, 62, 399}, },
            {},
            {},
            {{62, 62, 394}, },
            {},
            {},
            {{62, 62, 400}, },
            {{62, 62, 401}, },
            {},
            {},
            {{62, 62, 401}, },
            {{108, 108, 402}, {112, 112, 403}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 82, 228}, {83, 83, 404}, {84, 65500, -28}, },
            {{48, 57, 227}, {65, 88, 228}, {89, 89, 405}, {90, 65500, -42}, },
            {{48, 82, -231}, {83, 83, 406}, {84, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 70, 228}, {71, 71, 407}, {72, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 67, 228}, {68, 68, 408}, {69, 78, 228}, {79, 79, 409}, {80, 65500, -29}, },
            {{48, 82, -231}, {83, 83, 410}, {84, 65500, -28}, },
            {{48, 57, 227}, {65, 78, 228}, {79, 79, 411}, {80, 65500, -29}, },
            {{48, 57, 227}, {65, 76, 228}, {77, 77, 412}, {78, 78, 413}, {79, 84, 228}, {85, 85, 414}, {86, 65500, -31}, },
            {{48, 69, -35}, {70, 70, 415}, {71, 90, 228}, {95, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 76, -291}, {77, 77, 416}, {78, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 83, 228}, {84, 84, 417}, {85, 90, 228}, {95, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 418}, {84, 65500, -28}, },
            {{48, 67, -288}, {68, 68, 419}, {69, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 81, 228}, {82, 82, 420}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 421}, {70, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 79, 228}, {80, 80, 422}, {81, 83, 228}, {84, 84, 423}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 75, 228}, {76, 76, 424}, {77, 90, 228}, {95, 65500, -28}, },
            {{48, 77, -44}, {78, 78, 425}, {79, 65500, -35}, },
            {{48, 81, -298}, {82, 82, 426}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 427}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 428}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 79, -300}, {80, 80, 429}, {81, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 66, 228}, {67, 67, 430}, {68, 72, 228}, {73, 73, 431}, {74, 83, 228}, {84, 84, 432}, {85, 85, 228}, {86, 86, 433}, {87, 90, 228}, {95, 65500, -28}, },
            {{48, 83, -295}, {84, 84, 434}, {85, 65500, -295}, },
            {{48, 66, -308}, {67, 67, 435}, {68, 90, 228}, {95, 65500, -28}, },
            {{48, 66, -308}, {67, 67, 436}, {68, 87, 228}, {88, 88, 437}, {89, 65500, -32}, },
            {{48, 77, -44}, {78, 78, 438}, {79, 65500, -35}, },
            {{48, 67, -288}, {68, 68, 439}, {69, 65500, -297}, },
            {{48, 83, -295}, {84, 84, 440}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 441}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 86, 228}, {87, 87, 442}, {88, 90, 228}, {95, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 443}, {70, 78, 228}, {79, 79, 444}, {80, 65500, -29}, },
            {{48, 69, -35}, {70, 70, 445}, {71, 65500, -292}, },
            {{48, 75, -301}, {76, 76, 446}, {77, 65500, -301}, },
            {{48, 68, -29}, {69, 69, 447}, {70, 75, 228}, {76, 76, 448}, {77, 83, 228}, {84, 84, 449}, {85, 65500, -295}, },
            {{48, 70, -287}, {71, 71, 450}, {72, 65500, -287}, },
            {{48, 81, -298}, {82, 82, 451}, {83, 65500, -39}, },
            {{48, 82, -231}, {83, 83, 452}, {84, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 453}, {70, 65500, -299}, },
            {{48, 57, 227}, {65, 84, 228}, {85, 85, 454}, {86, 65500, -31}, },
            {{48, 79, -300}, {80, 80, 455}, {81, 65500, -307}, },
            {{48, 72, -32}, {73, 73, 456}, {74, 90, 228}, {95, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 457}, {70, 65500, -299}, },
            {{48, 75, -301}, {76, 76, 458}, {77, 81, 228}, {82, 82, 459}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 460}, {70, 72, 228}, {73, 73, 461}, {74, 65500, -330}, },
            {},
            {{47, 47, 462}, },
            {{48, 95, -34}, {97, 104, 228}, {105, 105, 463}, {106, 65500, -63}, },
            {{48, 95, -34}, {97, 97, 464}, {98, 122, 228}, {170, 65500, -28}, },
            {{48, 109, -66}, {110, 110, 465}, {111, 65500, -66}, },
            {{48, 110, -55}, {111, 111, 466}, {112, 65500, -54}, },
            {{48, 113, -52}, {114, 114, 467}, {115, 65500, -52}, },
            {{48, 113, -52}, {114, 114, 468}, {115, 65500, -52}, },
            {{48, 110, -55}, {111, 111, 469}, {112, 65500, -54}, },
            {{48, 109, -66}, {110, 110, 470}, {111, 65500, -66}, },
            {{48, 95, -34}, {97, 108, 228}, {109, 109, 471}, {110, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 115, 228}, {116, 116, 472}, {117, 65500, -53}, },
            {{48, 113, -52}, {114, 114, 473}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 98, 228}, {99, 99, 474}, {100, 122, 228}, {170, 65500, -28}, },
            {{48, 110, -55}, {111, 111, 475}, {112, 65500, -54}, },
            {{48, 65500, -34}, },
            {{48, 101, -53}, {102, 102, 476}, {103, 115, 228}, {116, 116, 477}, {117, 65500, -53}, },
            {{48, 100, -62}, {101, 101, 478}, {102, 65500, -58}, },
            {{48, 100, -62}, {101, 101, 479}, {102, 65500, -58}, },
            {{48, 95, -34}, {97, 114, 228}, {115, 115, 480}, {116, 122, 228}, {170, 65500, -28}, },
            {{48, 101, -53}, {102, 102, 481}, {103, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 119, 228}, {120, 120, 482}, {121, 122, 228}, {170, 65500, -28}, },
            {{48, 109, -66}, {110, 110, 483}, {111, 113, 228}, {114, 114, 484}, {115, 65500, -52}, },
            {{48, 99, -57}, {100, 100, 485}, {101, 122, 228}, {170, 65500, -28}, },
            {{48, 115, -345}, {116, 116, 486}, {117, 65500, -53}, },
            {{48, 65500, -34}, },
            {{48, 113, -52}, {114, 114, 487}, {115, 65500, -52}, },
            {{48, 114, -353}, {115, 115, 488}, {116, 65500, -353}, },
            {{48, 100, -62}, {101, 101, 489}, {102, 105, 228}, {106, 106, 490}, {107, 122, 228}, {170, 65500, -28}, },
            {{48, 109, -66}, {110, 110, 491}, {111, 65500, -66}, },
            {{48, 98, -347}, {99, 99, 492}, {100, 107, 228}, {108, 108, 493}, {109, 117, 228}, {118, 118, 494}, {119, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 102, 228}, {103, 103, 495}, {104, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 112, 228}, {113, 113, 496}, {114, 122, 228}, {170, 65500, -28}, },
            {{48, 95, -34}, {97, 121, 228}, {122, 122, 497}, {170, 65500, -28}, },
            {{48, 104, -336}, {105, 105, 498}, {106, 65500, -63}, },
            {{48, 109, -66}, {110, 110, 499}, {111, 65500, -66}, },
            {{48, 113, -52}, {114, 114, 500}, {115, 65500, -52}, },
            {{48, 95, -34}, {97, 97, 228}, {98, 98, 501}, {99, 99, 502}, {100, 65500, -347}, },
            {{48, 104, -336}, {105, 105, 503}, {106, 65500, -63}, },
            {{48, 95, -34}, {97, 111, 228}, {112, 112, 504}, {113, 122, 228}, {170, 65500, -28}, },
            {{48, 100, -62}, {101, 101, 505}, {102, 65500, -58}, },
            {{48, 104, -336}, {105, 105, 506}, {106, 65500, -63}, },
            {{62, 62, 507}, },
            {{62, 62, 508}, },
            {},
            {},
            {{48, 65500, -34}, },
            {},
            {{48, 65500, -34}, },
            {},
            {{0, 65535, -6}, },
            {},
            {{62, 62, 509}, },
            {{62, 62, 510}, },
            {},
            {{0, 65535, -201}, },
            {},
            {},
            {{58, 58, 511}, },
            {},
            {{48, 102, -207}, },
            {},
            {{62, 62, 512}, },
            {{62, 62, 513}, },
            {},
            {},
            {{62, 62, 513}, },
            {},
            {{62, 62, 514}, },
            {{62, 62, 515}, },
            {{105, 105, 516}, },
            {{114, 114, 517}, },
            {{48, 83, -295}, {84, 84, 518}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 519}, {70, 65500, -299}, },
            {{48, 72, -32}, {73, 73, 520}, {74, 65500, -330}, },
            {{48, 88, -232}, {89, 89, 521}, {90, 65500, -42}, },
            {{48, 75, -301}, {76, 76, 522}, {77, 65500, -301}, },
            {{48, 68, -29}, {69, 69, 523}, {70, 65500, -299}, },
            {{48, 72, -32}, {73, 73, 524}, {74, 65500, -330}, },
            {{48, 79, -300}, {80, 80, 525}, {81, 65500, -307}, },
            {{48, 66, -308}, {67, 67, 526}, {68, 82, 228}, {83, 83, 527}, {84, 65500, -28}, },
            {{48, 77, -44}, {78, 78, 528}, {79, 65500, -35}, },
            {{48, 72, -32}, {73, 73, 529}, {74, 65500, -330}, },
            {{48, 76, -291}, {77, 77, 530}, {78, 65500, -294}, },
            {{48, 71, -43}, {72, 72, 531}, {73, 65500, -46}, },
            {{48, 68, -29}, {69, 69, 532}, {70, 72, 228}, {73, 73, 533}, {74, 65500, -330}, },
            {{48, 65500, -34}, },
            {{48, 78, -290}, {79, 79, 534}, {80, 65500, -29}, },
            {{48, 77, -44}, {78, 78, 535}, {79, 65500, -35}, },
            {{48, 68, -29}, {69, 69, 536}, {70, 81, 228}, {82, 82, 537}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 538}, {70, 65500, -299}, },
            {{48, 82, -231}, {83, 83, 539}, {84, 65500, -28}, },
            {{48, 48, 227}, {49, 49, 540}, {50, 8319, -120}, {8450, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 541}, {70, 65500, -299}, },
            {{48, 66, -308}, {67, 67, 542}, {68, 65500, -310}, },
            {{48, 75, -301}, {76, 76, 543}, {77, 78, 228}, {79, 79, 544}, {80, 65500, -29}, },
            {{48, 75, -301}, {76, 76, 545}, {77, 65500, -301}, },
            {{48, 83, -295}, {84, 84, 546}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 547}, {70, 65500, -299}, },
            {{48, 57, 227}, {65, 65, 548}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 549}, {66, 65500, -38}, },
            {{48, 71, -43}, {72, 72, 550}, {73, 65500, -46}, },
            {{48, 72, -32}, {73, 73, 551}, {74, 65500, -330}, },
            {{48, 72, -32}, {73, 73, 552}, {74, 65500, -330}, },
            {{48, 68, -29}, {69, 69, 553}, {70, 65500, -299}, },
            {{48, 48, 227}, {49, 49, 554}, {50, 57, 227}, {65, 84, 228}, {85, 85, 555}, {86, 65500, -31}, },
            {{48, 81, -298}, {82, 82, 556}, {83, 65500, -39}, },
            {{48, 48, 227}, {49, 49, 557}, {50, 65500, -427}, },
            {{48, 67, -288}, {68, 68, 558}, {69, 65500, -297}, },
            {{48, 76, -291}, {77, 77, 559}, {78, 79, 228}, {80, 80, 560}, {81, 65500, -307}, },
            {{48, 68, -29}, {69, 69, 561}, {70, 72, 228}, {73, 73, 562}, {74, 65500, -330}, },
            {{48, 68, -29}, {69, 69, 563}, {70, 65500, -299}, },
            {{48, 82, -231}, {83, 83, 564}, {84, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 565}, {70, 65500, -299}, },
            {{48, 82, -231}, {83, 83, 566}, {84, 65500, -28}, },
            {{48, 76, -291}, {77, 77, 567}, {78, 65500, -294}, },
            {{48, 72, -32}, {73, 73, 568}, {74, 65500, -330}, },
            {{48, 83, -295}, {84, 84, 569}, {85, 65500, -295}, },
            {{48, 77, -44}, {78, 78, 570}, {79, 65500, -35}, },
            {{48, 68, -29}, {69, 69, 571}, {70, 65500, -299}, },
            {{48, 68, -29}, {69, 69, 572}, {70, 65500, -299}, },
            {{48, 78, -290}, {79, 79, 573}, {80, 65500, -29}, },
            {{48, 82, -231}, {83, 83, 574}, {84, 65500, -28}, },
            {{48, 84, -328}, {85, 85, 575}, {86, 65500, -31}, },
            {{48, 72, -32}, {73, 73, 576}, {74, 65500, -330}, },
            {{48, 77, -44}, {78, 78, 577}, {79, 81, 228}, {82, 82, 578}, {83, 65500, -39}, },
            {{48, 75, -301}, {76, 76, 579}, {77, 65500, -301}, },
            {},
            {{48, 115, -345}, {116, 116, 580}, {117, 65500, -53}, },
            {{48, 95, -34}, {97, 107, 228}, {108, 108, 581}, {109, 122, 228}, {170, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 107, -466}, {108, 108, 582}, {109, 65500, -466}, },
            {{48, 100, -62}, {101, 101, 583}, {102, 116, 228}, {117, 117, 584}, {118, 65500, -64}, },
            {{48, 99, -57}, {100, 100, 585}, {101, 65500, -357}, },
            {{48, 114, -353}, {115, 115, 586}, {116, 65500, -353}, },
            {{48, 98, -347}, {99, 99, 587}, {100, 114, 228}, {115, 115, 588}, {116, 65500, -353}, },
            {{48, 65500, -34}, },
            {{48, 95, -34}, {97, 103, 228}, {104, 104, 589}, {105, 122, 228}, {170, 65500, -28}, },
            {{48, 114, -353}, {115, 115, 590}, {116, 65500, -353}, },
            {{48, 65500, -34}, },
            {{48, 109, -66}, {110, 110, 591}, {111, 65500, -66}, },
            {{48, 104, -336}, {105, 105, 592}, {106, 65500, -63}, },
            {{48, 100, -62}, {101, 101, 593}, {102, 65500, -58}, },
            {{48, 112, -366}, {113, 113, 594}, {114, 65500, -366}, },
            {{48, 113, -52}, {114, 114, 595}, {115, 65500, -52}, },
            {{48, 115, -345}, {116, 116, 596}, {117, 65500, -53}, },
            {{48, 115, -345}, {116, 116, 597}, {117, 65500, -53}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 113, -52}, {114, 114, 598}, {115, 65500, -52}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 108, -344}, {109, 109, 599}, {110, 65500, -344}, },
            {{48, 115, -345}, {116, 116, 600}, {117, 65500, -53}, },
            {{48, 99, -57}, {100, 100, 601}, {101, 101, 228}, {102, 102, 602}, {103, 65500, -354}, },
            {{48, 48, 227}, {49, 49, 603}, {50, 50, 604}, {51, 57, 227}, {65, 65500, -34}, },
            {{48, 95, -34}, {97, 106, 228}, {107, 107, 605}, {108, 122, 228}, {170, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 103, -474}, {104, 104, 606}, {105, 65500, -474}, },
            {{48, 48, 227}, {49, 49, 607}, {50, 65500, -427}, },
            {{48, 100, -62}, {101, 101, 608}, {102, 65500, -58}, },
            {{48, 111, -373}, {112, 112, 609}, {113, 65500, -373}, },
            {{48, 114, -353}, {115, 115, 610}, {116, 65500, -353}, },
            {{48, 95, -34}, {97, 116, 228}, {117, 117, 611}, {118, 65500, -64}, },
            {{48, 115, -345}, {116, 116, 612}, {117, 65500, -53}, },
            {{48, 98, -347}, {99, 99, 613}, {100, 65500, -347}, },
            {{48, 107, -466}, {108, 108, 614}, {109, 65500, -466}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 615}, {102, 65500, -58}, },
            {{48, 110, -55}, {111, 111, 616}, {112, 65500, -54}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 617}, },
            {},
            {},
            {{116, 116, 618}, },
            {{101, 101, 619}, },
            {{48, 81, -298}, {82, 82, 620}, {83, 65500, -39}, },
            {{48, 81, -298}, {82, 82, 621}, {83, 65500, -39}, },
            {{48, 77, -44}, {78, 78, 622}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 66, -308}, {67, 67, 623}, {68, 65500, -310}, },
            {{48, 84, -328}, {85, 85, 624}, {86, 65500, -31}, },
            {{48, 81, -298}, {82, 82, 625}, {83, 65500, -39}, },
            {{48, 83, -295}, {84, 84, 626}, {85, 65500, -295}, },
            {{48, 83, -295}, {84, 84, 627}, {85, 65500, -295}, },
            {{48, 77, -44}, {78, 78, 628}, {79, 65500, -35}, },
            {{48, 88, -232}, {89, 89, 629}, {90, 65500, -42}, },
            {{48, 68, -29}, {69, 69, 630}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 69, -35}, {70, 70, 631}, {71, 65500, -292}, },
            {{48, 81, -298}, {82, 82, 632}, {83, 65500, -39}, },
            {{48, 83, -295}, {84, 84, 633}, {85, 65500, -295}, },
            {{48, 66, -308}, {67, 67, 634}, {68, 65500, -310}, },
            {{48, 68, -29}, {69, 69, 635}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 636}, {79, 65500, -35}, },
            {{48, 68, -29}, {69, 69, 637}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 83, -295}, {84, 84, 638}, {85, 65500, -295}, },
            {{48, 83, -295}, {84, 84, 639}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 640}, {70, 65500, -299}, },
            {{48, 81, -298}, {82, 82, 641}, {83, 65500, -39}, },
            {{48, 84, -328}, {85, 85, 642}, {86, 65500, -31}, },
            {{48, 72, -32}, {73, 73, 643}, {74, 65500, -330}, },
            {{48, 70, -287}, {71, 71, 644}, {72, 81, 228}, {82, 82, 645}, {83, 65500, -39}, },
            {{48, 81, -298}, {82, 82, 646}, {83, 65500, -39}, },
            {{48, 75, -301}, {76, 76, 647}, {77, 65500, -301}, },
            {{48, 72, -32}, {73, 73, 648}, {74, 65500, -330}, },
            {{48, 77, -44}, {78, 78, 649}, {79, 65500, -35}, },
            {{48, 77, -44}, {78, 78, 650}, {79, 65500, -35}, },
            {{48, 75, -301}, {76, 76, 651}, {77, 65500, -301}, },
            {{48, 65500, -34}, },
            {{48, 81, -298}, {82, 82, 652}, {83, 65500, -39}, },
            {{48, 57, 227}, {65, 65, 653}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 72, -32}, {73, 73, 654}, {74, 65500, -330}, },
            {{48, 78, -290}, {79, 79, 655}, {80, 65500, -29}, },
            {{48, 68, -29}, {69, 69, 656}, {70, 65500, -299}, },
            {{48, 81, -298}, {82, 82, 657}, {83, 65500, -39}, },
            {{48, 77, -44}, {78, 78, 658}, {79, 65500, -35}, },
            {{48, 82, -231}, {83, 83, 659}, {84, 90, 228}, {95, 95, 660}, {97, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 66, -308}, {67, 67, 661}, {68, 65500, -310}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 662}, {66, 65500, -38}, },
            {{48, 77, -44}, {78, 78, 663}, {79, 65500, -35}, },
            {{48, 68, -29}, {69, 69, 664}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 665}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 666}, {70, 65500, -299}, },
            {{48, 57, 227}, {65, 65, 667}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 668}, {70, 65500, -299}, },
            {{48, 68, -29}, {69, 69, 669}, {70, 65500, -299}, },
            {{48, 95, -34}, {97, 120, 228}, {121, 121, 670}, {122, 122, 228}, {170, 65500, -28}, },
            {{48, 114, -353}, {115, 115, 671}, {116, 65500, -353}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 672}, {102, 65500, -58}, },
            {{48, 100, -62}, {101, 101, 673}, {102, 65500, -58}, },
            {{48, 65500, -34}, },
            {{48, 116, -502}, {117, 117, 674}, {118, 65500, -64}, },
            {{48, 65500, -34}, },
            {{48, 115, -345}, {116, 116, 675}, {117, 65500, -53}, },
            {{48, 100, -62}, {101, 101, 676}, {102, 65500, -58}, },
            {{48, 115, -345}, {116, 116, 677}, {117, 65500, -53}, },
            {{48, 115, -345}, {116, 116, 678}, {117, 65500, -53}, },
            {{48, 119, -355}, {120, 120, 679}, {121, 65500, -355}, },
            {{48, 113, -52}, {114, 114, 680}, {115, 65500, -52}, },
            {{48, 48, 227}, {49, 49, 681}, {50, 65500, -427}, },
            {{48, 95, -34}, {97, 97, 682}, {98, 65500, -337}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 110, -55}, {111, 111, 683}, {112, 65500, -54}, },
            {{48, 65500, -34}, },
            {{48, 101, -53}, {102, 102, 684}, {103, 65500, -354}, },
            {{48, 65500, -34}, },
            {{48, 104, -336}, {105, 105, 685}, {106, 65500, -63}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 115, -345}, {116, 116, 686}, {117, 65500, -53}, },
            {{48, 65500, -34}, },
            {{48, 115, -345}, {116, 116, 687}, {117, 65500, -53}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 98, -347}, {99, 99, 688}, {100, 65500, -347}, },
            {{48, 113, -52}, {114, 114, 689}, {115, 65500, -52}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 109, -66}, {110, 110, 690}, {111, 65500, -66}, },
            {},
            {{101, 101, 691}, },
            {{100, 100, 692}, },
            {{48, 57, 227}, {65, 65, 693}, {66, 65500, -38}, },
            {{48, 83, -295}, {84, 84, 694}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 695}, {70, 65500, -299}, },
            {{48, 83, -295}, {84, 84, 696}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 697}, {70, 65500, -299}, },
            {{48, 57, 227}, {65, 65, 698}, {66, 81, 228}, {82, 82, 699}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 700}, {70, 65500, -299}, },
            {{48, 68, -29}, {69, 69, 701}, {70, 72, 228}, {73, 73, 702}, {74, 65500, -330}, },
            {{48, 90, -34}, {95, 95, 703}, {97, 65500, -28}, },
            {{48, 81, -298}, {82, 82, 704}, {83, 65500, -39}, },
            {{48, 65500, -34}, },
            {{48, 90, -34}, {95, 95, 705}, {97, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 706}, {84, 65500, -28}, },
            {{48, 83, -295}, {84, 84, 707}, {85, 65500, -295}, },
            {{48, 82, -231}, {83, 83, 708}, {84, 65500, -28}, },
            {{48, 67, -288}, {68, 68, 709}, {69, 65500, -297}, },
            {{48, 65500, -34}, },
            {{48, 88, -232}, {89, 89, 710}, {90, 65500, -42}, },
            {{48, 72, -32}, {73, 73, 711}, {74, 65500, -330}, },
            {{48, 76, -291}, {77, 77, 712}, {78, 65500, -294}, },
            {{48, 83, -295}, {84, 84, 713}, {85, 65500, -295}, },
            {{48, 67, -288}, {68, 68, 714}, {69, 65500, -297}, },
            {{48, 57, 227}, {65, 65, 715}, {66, 65500, -38}, },
            {{48, 68, -29}, {69, 69, 716}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 72, -32}, {73, 73, 717}, {74, 65500, -330}, },
            {{48, 90, -34}, {95, 95, 718}, {97, 65500, -28}, },
            {{48, 77, -44}, {78, 78, 719}, {79, 65500, -35}, },
            {{48, 83, -295}, {84, 84, 720}, {85, 65500, -295}, },
            {{48, 83, -295}, {84, 84, 721}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 722}, {66, 65500, -38}, },
            {{48, 83, -295}, {84, 84, 723}, {85, 65500, -295}, },
            {{48, 66, -308}, {67, 67, 724}, {68, 65500, -310}, },
            {{48, 83, -295}, {84, 84, 725}, {85, 65500, -295}, },
            {{48, 81, -298}, {82, 82, 726}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 727}, {70, 65500, -299}, },
            {{48, 68, -29}, {69, 69, 728}, {70, 65500, -299}, },
            {{48, 90, -34}, {95, 95, 729}, {97, 65500, -28}, },
            {{48, 69, -35}, {70, 70, 730}, {71, 65500, -292}, },
            {{48, 83, -295}, {84, 84, 731}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 70, -287}, {71, 71, 732}, {72, 65500, -287}, },
            {{48, 76, -291}, {77, 77, 733}, {78, 65500, -294}, },
            {{48, 65500, -34}, },
            {{48, 82, -231}, {83, 83, 734}, {84, 65500, -28}, },
            {{48, 65, -28}, {66, 66, 735}, {67, 77, 228}, {78, 78, 736}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 737}, {102, 65500, -58}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 113, -52}, {114, 114, 738}, {115, 65500, -52}, },
            {{48, 65500, -34}, },
            {{48, 113, -52}, {114, 114, 739}, {115, 65500, -52}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 115, -345}, {116, 116, 740}, {117, 65500, -53}, },
            {{48, 113, -52}, {114, 114, 741}, {115, 65500, -52}, },
            {{48, 104, -336}, {105, 105, 742}, {106, 65500, -63}, },
            {{48, 119, -355}, {120, 120, 743}, {121, 65500, -355}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 115, -345}, {116, 116, 744}, {117, 65500, -53}, },
            {{48, 100, -62}, {101, 101, 745}, {102, 65500, -58}, },
            {{48, 65500, -34}, },
            {{114, 114, 746}, },
            {{105, 105, 747}, },
            {{48, 66, -308}, {67, 67, 748}, {68, 65500, -310}, },
            {{48, 72, -32}, {73, 73, 749}, {74, 65500, -330}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 750}, {66, 65500, -38}, },
            {{48, 83, -295}, {84, 84, 751}, {85, 65500, -295}, },
            {{48, 77, -44}, {78, 78, 752}, {79, 65500, -35}, },
            {{48, 57, 227}, {65, 65, 753}, {66, 65500, -38}, },
            {{48, 81, -298}, {82, 82, 754}, {83, 65500, -39}, },
            {{48, 65500, -34}, },
            {{48, 83, -295}, {84, 84, 755}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 85, 228}, {86, 86, 756}, {87, 65500, -308}, },
            {{48, 65500, -34}, },
            {{48, 83, -295}, {84, 84, 757}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 82, -231}, {83, 83, 758}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 759}, {84, 65500, -28}, },
            {{48, 79, -300}, {80, 80, 760}, {81, 65500, -307}, },
            {{48, 78, -290}, {79, 79, 761}, {80, 65500, -29}, },
            {{48, 68, -29}, {69, 69, 762}, {70, 65500, -299}, },
            {{48, 82, -231}, {83, 83, 763}, {84, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 764}, {70, 65500, -299}, },
            {{48, 75, -301}, {76, 76, 765}, {77, 65500, -301}, },
            {{48, 81, -298}, {82, 82, 766}, {83, 65500, -39}, },
            {{48, 57, 227}, {65, 65, 767}, {66, 65500, -38}, },
            {{48, 78, -290}, {79, 79, 768}, {80, 65500, -29}, },
            {{48, 68, -29}, {69, 69, 769}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 75, -301}, {76, 76, 770}, {77, 65500, -301}, },
            {{48, 72, -32}, {73, 73, 771}, {74, 65500, -330}, },
            {{48, 57, 227}, {65, 65, 772}, {66, 65500, -38}, },
            {{48, 68, -29}, {69, 69, 773}, {70, 65500, -299}, },
            {{48, 83, -295}, {84, 84, 774}, {85, 65500, -295}, },
            {{48, 77, -44}, {78, 78, 775}, {79, 65500, -35}, },
            {{48, 76, -291}, {77, 77, 776}, {78, 82, 228}, {83, 83, 777}, {84, 65500, -28}, },
            {{48, 76, -291}, {77, 77, 778}, {78, 65500, -294}, },
            {{48, 57, 227}, {65, 65, 779}, {66, 78, 228}, {79, 79, 780}, {80, 65500, -29}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 75, -301}, {76, 76, 781}, {77, 65500, -301}, },
            {{48, 83, -295}, {84, 84, 782}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 783}, {102, 65500, -58}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 784}, {102, 65500, -58}, },
            {{48, 65500, -34}, },
            {{48, 119, -355}, {120, 120, 785}, {121, 65500, -355}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 100, -62}, {101, 101, 786}, {102, 65500, -58}, },
            {{97, 97, 787}, },
            {{99, 99, 788}, },
            {{48, 83, -295}, {84, 84, 789}, {85, 65500, -295}, },
            {{48, 78, -290}, {79, 79, 790}, {80, 65500, -29}, },
            {{48, 83, -295}, {84, 84, 791}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 792}, {70, 65500, -299}, },
            {{48, 83, -295}, {84, 84, 793}, {85, 65500, -295}, },
            {{48, 72, -32}, {73, 73, 794}, {74, 65500, -330}, },
            {{48, 68, -29}, {69, 69, 795}, {70, 65500, -299}, },
            {{48, 72, -32}, {73, 73, 796}, {74, 65500, -330}, },
            {{48, 57, 227}, {65, 65, 797}, {66, 65500, -38}, },
            {{48, 88, -232}, {89, 89, 798}, {90, 65500, -42}, },
            {{48, 72, -32}, {73, 73, 799}, {74, 65500, -330}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 800}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 801}, {79, 65500, -35}, },
            {{48, 77, -44}, {78, 78, 802}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 82, -231}, {83, 83, 803}, {84, 65500, -28}, },
            {{48, 72, -32}, {73, 73, 804}, {74, 65500, -330}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 805}, {79, 65500, -35}, },
            {{48, 79, -300}, {80, 80, 806}, {81, 65500, -307}, },
            {{48, 65500, -34}, },
            {{48, 48, 227}, {49, 49, 807}, {50, 65500, -427}, },
            {{48, 78, -290}, {79, 79, 808}, {80, 65500, -29}, },
            {{48, 83, -295}, {84, 84, 809}, {85, 65500, -295}, },
            {{48, 82, -231}, {83, 83, 810}, {84, 65500, -28}, },
            {{48, 72, -32}, {73, 73, 811}, {74, 65500, -330}, },
            {{48, 66, -308}, {67, 67, 812}, {68, 65500, -310}, },
            {{48, 68, -29}, {69, 69, 813}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 814}, {66, 65500, -38}, },
            {{48, 72, -32}, {73, 73, 815}, {74, 65500, -330}, },
            {{48, 81, -298}, {82, 82, 816}, {83, 65500, -39}, },
            {{48, 68, -29}, {69, 69, 817}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 48, 227}, {49, 49, 818}, {50, 65500, -427}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{108, 108, 819}, },
            {{97, 97, 820}, },
            {{48, 90, -34}, {95, 95, 821}, {97, 65500, -28}, },
            {{48, 77, -44}, {78, 78, 822}, {79, 65500, -35}, },
            {{48, 72, -32}, {73, 73, 823}, {74, 65500, -330}, },
            {{48, 90, -34}, {95, 95, 824}, {97, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 825}, {84, 65500, -28}, },
            {{48, 77, -44}, {78, 78, 826}, {79, 65500, -35}, },
            {{48, 57, 227}, {65, 87, 228}, {88, 88, 827}, {89, 65500, -32}, },
            {{48, 78, -290}, {79, 79, 828}, {80, 65500, -29}, },
            {{48, 75, -301}, {76, 76, 829}, {77, 65500, -301}, },
            {{48, 79, -300}, {80, 80, 830}, {81, 65500, -307}, },
            {{48, 78, -290}, {79, 79, 831}, {80, 65500, -29}, },
            {{48, 82, -231}, {83, 83, 832}, {84, 65500, -28}, },
            {{48, 65500, -34}, },
            {{48, 83, -295}, {84, 84, 833}, {85, 65500, -295}, },
            {{48, 65500, -34}, },
            {{48, 82, -231}, {83, 83, 834}, {84, 89, 228}, {90, 90, 835}, {95, 65500, -28}, },
            {{48, 83, -295}, {84, 84, 836}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 837}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 838}, {79, 65500, -35}, },
            {{48, 68, -29}, {69, 69, 839}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 68, -29}, {69, 69, 840}, {70, 65500, -299}, },
            {{48, 68, -29}, {69, 69, 841}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 842}, {79, 65500, -35}, },
            {{48, 66, -308}, {67, 67, 843}, {68, 65500, -310}, },
            {{48, 75, -301}, {76, 76, 844}, {77, 65500, -301}, },
            {{48, 57, 227}, {65, 65, 845}, {66, 65500, -38}, },
            {{48, 82, -231}, {83, 83, 846}, {84, 65500, -28}, },
            {{48, 65500, -34}, },
            {{95, 95, 847}, },
            {{116, 116, 848}, },
            {{48, 66, -308}, {67, 67, 849}, {68, 85, 228}, {86, 86, 850}, {87, 65500, -308}, },
            {{48, 82, -231}, {83, 83, 851}, {84, 65500, -28}, },
            {{48, 78, -290}, {79, 79, 852}, {80, 65500, -29}, },
            {{48, 66, -308}, {67, 67, 853}, {68, 85, 228}, {86, 86, 854}, {87, 65500, -308}, },
            {{48, 65500, -34}, },
            {{48, 83, -295}, {84, 84, 855}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 65, 856}, {66, 65500, -38}, },
            {{48, 77, -44}, {78, 78, 857}, {79, 65500, -35}, },
            {{48, 84, -328}, {85, 85, 858}, {86, 65500, -31}, },
            {{48, 68, -29}, {69, 69, 859}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 860}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{48, 57, 227}, {65, 65, 861}, {66, 65500, -38}, },
            {{48, 57, 227}, {65, 65, 862}, {66, 65500, -38}, },
            {{48, 57, 227}, {65, 65, 863}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 81, -298}, {82, 82, 864}, {83, 65500, -39}, },
            {{48, 82, -231}, {83, 83, 865}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 866}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 867}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 868}, {84, 65500, -28}, },
            {{48, 83, -295}, {84, 84, 869}, {85, 65500, -295}, },
            {{48, 71, -43}, {72, 72, 870}, {73, 65500, -46}, },
            {{48, 65500, -34}, },
            {{48, 75, -301}, {76, 76, 871}, {77, 65500, -301}, },
            {{48, 65500, -34}, },
            {{112, 112, 872}, {115, 115, 873}, },
            {{101, 101, 874}, },
            {{48, 78, -290}, {79, 79, 875}, {80, 65500, -29}, },
            {{48, 57, 227}, {65, 65, 876}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 877}, {79, 65500, -35}, },
            {{48, 78, -290}, {79, 79, 878}, {80, 65500, -29}, },
            {{48, 57, 227}, {65, 65, 879}, {66, 65500, -38}, },
            {{48, 82, -231}, {83, 83, 880}, {84, 65500, -28}, },
            {{48, 76, -291}, {77, 77, 881}, {78, 65500, -294}, },
            {{48, 82, -231}, {83, 83, 882}, {84, 65500, -28}, },
            {{48, 68, -29}, {69, 69, 883}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{48, 82, -231}, {83, 83, 884}, {84, 65500, -28}, },
            {{48, 83, -295}, {84, 84, 885}, {85, 65500, -295}, },
            {{48, 83, -295}, {84, 84, 886}, {85, 65500, -295}, },
            {{48, 83, -295}, {84, 84, 887}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 65, 888}, {66, 65500, -38}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 72, -32}, {73, 73, 889}, {74, 65500, -330}, },
            {{48, 75, -301}, {76, 76, 890}, {77, 65500, -301}, },
            {{114, 114, 891}, },
            {{117, 117, 892}, },
            {{95, 95, 893}, },
            {{48, 77, -44}, {78, 78, 894}, {79, 65500, -35}, },
            {{48, 81, -298}, {82, 82, 895}, {83, 65500, -39}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 896}, {79, 65500, -35}, },
            {{48, 81, -298}, {82, 82, 897}, {83, 65500, -39}, },
            {{48, 65500, -34}, },
            {{48, 79, -300}, {80, 80, 898}, {81, 65500, -307}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 72, -32}, {73, 73, 899}, {74, 65500, -330}, },
            {{48, 72, -32}, {73, 73, 900}, {74, 65500, -330}, },
            {{48, 72, -32}, {73, 73, 901}, {74, 65500, -330}, },
            {{48, 83, -295}, {84, 84, 902}, {85, 65500, -295}, },
            {{48, 77, -44}, {78, 78, 903}, {79, 65500, -35}, },
            {{48, 65500, -34}, },
            {{101, 101, 904}, },
            {{98, 98, 905}, },
            {{105, 105, 906}, },
            {{48, 82, -231}, {83, 83, 907}, {84, 65500, -28}, },
            {{48, 72, -32}, {73, 73, 908}, {74, 65500, -330}, },
            {{48, 82, -231}, {83, 83, 909}, {84, 65500, -28}, },
            {{48, 72, -32}, {73, 73, 910}, {74, 65500, -330}, },
            {{48, 75, -301}, {76, 76, 911}, {77, 65500, -301}, },
            {{48, 78, -290}, {79, 79, 912}, {80, 65500, -29}, },
            {{48, 78, -290}, {79, 79, 913}, {80, 65500, -29}, },
            {{48, 78, -290}, {79, 79, 914}, {80, 65500, -29}, },
            {{48, 72, -32}, {73, 73, 915}, {74, 65500, -330}, },
            {{48, 68, -29}, {69, 69, 916}, {70, 65500, -299}, },
            {{100, 100, 917}, },
            {{115, 115, 918}, },
            {{100, 100, 919}, },
            {{48, 83, -295}, {84, 84, 920}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 65, 921}, {66, 65500, -38}, },
            {{48, 83, -295}, {84, 84, 922}, {85, 65500, -295}, },
            {{48, 57, 227}, {65, 65, 923}, {66, 65500, -38}, },
            {{48, 68, -29}, {69, 69, 924}, {70, 65500, -299}, },
            {{48, 77, -44}, {78, 78, 925}, {79, 65500, -35}, },
            {{48, 77, -44}, {78, 78, 926}, {79, 65500, -35}, },
            {{48, 77, -44}, {78, 78, 927}, {79, 65500, -35}, },
            {{48, 78, -290}, {79, 79, 928}, {80, 65500, -29}, },
            {{48, 65500, -34}, },
            {{105, 105, 929}, },
            {{116, 116, 930}, },
            {{101, 101, 931}, },
            {{48, 57, 227}, {65, 65, 932}, {66, 65500, -38}, },
            {{48, 65, -28}, {66, 66, 933}, {67, 90, 228}, {95, 65500, -28}, },
            {{48, 57, 227}, {65, 65, 934}, {66, 65500, -38}, },
            {{48, 65, -28}, {66, 66, 935}, {67, 65500, -923}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 77, -44}, {78, 78, 936}, {79, 65500, -35}, },
            {{99, 99, 937}, },
            {{105, 105, 938}, },
            {{110, 110, 939}, },
            {{48, 77, -44}, {78, 78, 940}, {79, 65500, -35}, },
            {{48, 75, -301}, {76, 76, 941}, {77, 65500, -301}, },
            {{48, 77, -44}, {78, 78, 942}, {79, 65500, -35}, },
            {{48, 75, -301}, {76, 76, 943}, {77, 65500, -301}, },
            {{48, 82, -231}, {83, 83, 944}, {84, 65500, -28}, },
            {{97, 97, 945}, },
            {{116, 116, 946}, },
            {{116, 116, 947}, },
            {{48, 83, -295}, {84, 84, 948}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 949}, {70, 65500, -299}, },
            {{48, 83, -295}, {84, 84, 950}, {85, 65500, -295}, },
            {{48, 68, -29}, {69, 69, 951}, {70, 65500, -299}, },
            {{48, 65500, -34}, },
            {{116, 116, 952}, },
            {{117, 117, 953}, },
            {{105, 105, 954}, },
            {{48, 82, -231}, {83, 83, 955}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 956}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 957}, {84, 65500, -28}, },
            {{48, 82, -231}, {83, 83, 958}, {84, 65500, -28}, },
            {{101, 101, 959}, },
            {{116, 116, 960}, },
            {{102, 102, 961}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{48, 65500, -34}, },
            {{65, 90, 962}, {97, 122, 963}, },
            {{105, 105, 964}, },
            {{105, 105, 965}, },
            {{65, 122, -961}, },
            {{65, 122, -961}, },
            {{111, 111, 966}, },
            {{101, 101, 967}, },
            {{110, 110, 968}, },
            {{114, 114, 969}, },
            {{65, 90, 970}, {97, 122, 971}, },
            {{65, 90, 972}, {97, 122, 973}, },
            {{65, 122, -970}, },
            {{65, 122, -970}, },
            {{65, 122, -971}, },
            {{65, 122, -971}, },
        }
        { // COMMENT
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 31, 1}, {32, 32, 2}, {33, 41, 1}, {42, 42, 4}, {43, 46, 1}, {47, 47, 5}, {48, 159, 1}, {160, 160, 2}, {161, 8231, 1}, {8232, 8233, 2}, {8234, 65535, 1}, },
            {{0, 41, 1}, {43, 46, 1}, {48, 65535, 1}, },
            {{0, 9, -2}, {10, 31, 1}, {32, 41, -2}, {43, 46, 1}, {48, 65535, -2}, },
            {{0, 65535, -3}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // MULTILINE_STRING_STATE
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 31, 1}, {32, 32, 2}, {33, 38, 1}, {39, 39, 4}, {40, 91, 1}, {92, 92, 5}, {93, 159, 1}, {160, 160, 2}, {161, 8231, 1}, {8232, 8233, 2}, {8234, 65535, 1}, },
            {{0, 38, 1}, {39, 39, 6}, {40, 92, -2}, {93, 65535, 1}, },
            {{0, 9, -2}, {10, 31, 1}, {32, 38, -2}, {39, 92, -3}, {93, 65535, -2}, },
            {{0, 65535, -3}, },
            {{0, 38, 7}, {39, 39, 8}, {40, 65535, 7}, },
            {{0, 38, 1}, {39, 39, 9}, {40, 65535, -3}, },
            {{0, 38, 7}, {39, 39, 10}, {40, 65535, 7}, },
            {{0, 65535, -3}, },
            {{0, 38, 11}, {39, 39, 12}, {40, 65535, 11}, },
            {{0, 38, 13}, {39, 39, 14}, {40, 91, 13}, {92, 92, 15}, {93, 65535, 13}, },
            {{0, 38, 11}, {40, 65535, 11}, },
            {{0, 65535, -3}, },
            {},
            {{0, 65535, -3}, },
            {{0, 38, 16}, {39, 39, 10}, {40, 65535, 16}, },
            {{0, 65535, -7}, },
            {{0, 65535, -3}, },
        }
        { // SHEBANG
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 31, 1}, {32, 32, 2}, {33, 34, 1}, {35, 35, 4}, {36, 159, 1}, {160, 160, 2}, {161, 8231, 1}, {8232, 8233, 2}, {8234, 65535, 1}, },
            {},
            {{9, 9, 5}, {32, 32, 5}, {160, 160, 5}, {8232, 8233, 5}, },
            {},
            {{33, 33, 6}, },
            {{9, 8233, -4}, },
            {},
        }
        { // PRAGMA
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 2}, {32, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 41, 3}, {42, 42, 5}, {43, 64, 3}, {65, 90, 6}, {91, 96, 3}, {97, 99, 6}, {100, 100, 7}, {101, 101, 6}, {102, 102, 8}, {103, 103, 9}, {104, 104, 6}, {105, 105, 10}, {106, 107, 6}, {108, 108, 11}, {109, 111, 6}, {112, 112, 12}, {113, 114, 6}, {115, 115, 13}, {116, 122, 6}, {123, 126, 3}, {160, 160, 1}, {170, 170, 14}, {181, 181, 14}, {186, 186, 15}, {191, 191, 3}, {192, 214, 16}, {215, 215, 3}, {216, 246, 16}, {247, 247, 3}, {248, 254, 16}, {255, 501, 15}, {506, 535, 17}, {592, 680, 17}, {688, 696, 17}, {699, 705, 17}, {720, 721, 18}, {736, 740, 18}, {890, 890, 18}, {902, 902, 18}, {904, 906, 19}, {908, 908, 19}, {910, 929, 19}, {931, 974, 19}, {976, 982, 20}, {986, 986, 20}, {988, 988, 20}, {990, 990, 20}, {992, 992, 21}, {994, 1011, 21}, {1025, 1036, 21}, {1038, 1103, 21}, {1105, 1116, 22}, {1118, 1153, 22}, {1168, 1220, 22}, {1223, 1224, 22}, {1227, 1228, 23}, {1232, 1259, 23}, {1262, 1269, 23}, {1272, 1273, 23}, {1329, 1366, 24}, {1369, 1369, 24}, {1377, 1415, 24}, {1488, 1514, 24}, {1520, 1522, 25}, {1569, 1594, 25}, {1600, 1610, 25}, {1649, 1719, 25}, {1722, 1726, 26}, {1728, 1742, 26}, {1744, 1747, 26}, {1749, 1749, 26}, {1765, 1766, 27}, {2309, 2361, 27}, {2365, 2365, 27}, {2392, 2401, 27}, {2437, 2444, 28}, {2447, 2448, 28}, {2451, 2472, 28}, {2474, 2480, 28}, {2482, 2482, 29}, {2486, 2489, 29}, {2524, 2525, 29}, {2527, 2529, 29}, {2544, 2545, 30}, {2565, 2570, 30}, {2575, 2576, 30}, {2579, 2600, 30}, {2602, 2608, 31}, {2610, 2611, 31}, {2613, 2614, 31}, {2616, 2617, 31}, {2649, 2652, 32}, {2654, 2654, 32}, {2674, 2676, 32}, {2693, 2699, 32}, {2701, 2701, 33}, {2703, 2705, 33}, {2707, 2728, 33}, {2730, 2736, 33}, {2738, 2739, 34}, {2741, 2745, 34}, {2749, 2749, 34}, {2784, 2784, 34}, {2821, 2828, 35}, {2831, 2832, 35}, {2835, 2856, 35}, {2858, 2864, 35}, {2866, 2867, 36}, {2870, 2873, 36}, {2877, 2877, 36}, {2908, 2909, 36}, {2911, 2913, 37}, {2949, 2954, 37}, {2958, 2960, 37}, {2962, 2965, 37}, {2969, 2970, 38}, {2972, 2972, 38}, {2974, 2975, 38}, {2979, 2980, 38}, {2984, 2986, 39}, {2990, 2997, 39}, {2999, 3001, 39}, {3077, 3084, 39}, {3086, 3088, 40}, {3090, 3112, 40}, {3114, 3123, 40}, {3125, 3129, 40}, {3168, 3169, 41}, {3205, 3212, 41}, {3214, 3216, 41}, {3218, 3240, 41}, {3242, 3251, 42}, {3253, 3257, 42}, {3294, 3294, 42}, {3296, 3297, 42}, {3333, 3340, 43}, {3342, 3344, 43}, {3346, 3368, 43}, {3370, 3385, 43}, {3424, 3425, 44}, {3585, 3630, 44}, {3632, 3632, 44}, {3634, 3635, 44}, {3648, 3654, 45}, {3713, 3714, 45}, {3716, 3716, 45}, {3719, 3720, 45}, {3722, 3722, 46}, {3725, 3725, 46}, {3732, 3735, 46}, {3737, 3743, 46}, {3745, 3747, 47}, {3749, 3749, 47}, {3751, 3751, 47}, {3754, 3755, 47}, {3757, 3758, 48}, {3760, 3760, 48}, {3762, 3763, 48}, {3773, 3773, 48}, {3776, 3780, 49}, {3782, 3782, 49}, {3804, 3805, 49}, {3904, 3911, 49}, {3913, 3945, 50}, {4256, 4293, 50}, {4304, 4342, 50}, {4352, 4441, 50}, {4447, 4514, 51}, {4520, 4601, 51}, {7680, 7835, 51}, {7840, 7929, 51}, {7936, 7957, 52}, {7960, 7965, 52}, {7968, 8005, 52}, {8008, 8013, 52}, {8016, 8023, 53}, {8025, 8025, 53}, {8027, 8027, 53}, {8029, 8029, 53}, {8031, 8061, 54}, {8064, 8116, 54}, {8118, 8124, 54}, {8126, 8126, 54}, {8130, 8132, 55}, {8134, 8140, 55}, {8144, 8147, 55}, {8150, 8155, 55}, {8160, 8172, 56}, {8178, 8180, 56}, {8182, 8188, 56}, {8232, 8233, 1}, {8319, 8319, 56}, {8450, 8450, 57}, {8455, 8455, 57}, {8458, 8467, 57}, {8469, 8469, 57}, {8472, 8477, 58}, {8484, 8484, 58}, {8486, 8486, 58}, {8488, 8488, 58}, {8490, 8497, 59}, {8499, 8504, 59}, {12293, 12293, 59}, {12337, 12341, 59}, {12353, 12436, 60}, {12443, 12446, 60}, {12449, 12538, 60}, {12540, 12542, 60}, {12549, 12588, 61}, {12593, 12686, 61}, {19968, 40869, 61}, {44032, 55203, 61}, {63744, 64045, 62}, {64256, 64262, 62}, {64275, 64279, 62}, {64287, 64296, 62}, {64298, 64310, 63}, {64312, 64316, 63}, {64318, 64318, 63}, {64320, 64321, 63}, {64323, 64324, 64}, {64326, 64433, 64}, {64467, 64829, 64}, {64848, 64911, 64}, {64914, 64967, 65}, {65008, 65019, 65}, {65136, 65138, 65}, {65140, 65140, 65}, {65142, 65276, 66}, {65313, 65338, 66}, {65345, 65370, 66}, {65382, 65470, 66}, {65474, 65479, 67}, {65482, 65487, 67}, {65490, 65495, 67}, {65498, 65500, 67}, },
            {{9, 9, 1}, {32, 32, 1}, {160, 160, 1}, {8232, 8233, 1}, },
            {},
            {{33, 33, 3}, {35, 41, 3}, {43, 126, 3}, {191, 254, 3}, },
            {{0, 9, 68}, {11, 12, 68}, {14, 33, 68}, {34, 34, 69}, {35, 91, 68}, {92, 92, 70}, {93, 65535, 68}, },
            {{47, 47, 71}, },
            {{33, 41, -5}, {43, 47, 3}, {48, 57, 72}, {58, 64, 3}, {65, 90, 73}, {91, 94, 3}, {95, 95, 74}, {96, 96, 3}, {97, 122, 73}, {123, 126, 3}, {170, 170, 75}, {181, 181, 75}, {186, 186, 76}, {191, 191, 3}, {192, 214, 77}, {215, 215, 3}, {216, 246, 77}, {247, 247, 3}, {248, 254, 77}, {255, 501, 76}, {506, 535, 78}, {592, 680, 78}, {688, 696, 78}, {699, 705, 78}, {720, 721, 79}, {736, 740, 79}, {890, 890, 79}, {902, 902, 79}, {904, 906, 80}, {908, 908, 80}, {910, 929, 80}, {931, 974, 80}, {976, 982, 81}, {986, 986, 81}, {988, 988, 81}, {990, 990, 81}, {992, 992, 82}, {994, 1011, 82}, {1025, 1036, 82}, {1038, 1103, 82}, {1105, 1116, 83}, {1118, 1153, 83}, {1168, 1220, 83}, {1223, 1224, 83}, {1227, 1228, 84}, {1232, 1259, 84}, {1262, 1269, 84}, {1272, 1273, 84}, {1329, 1366, 85}, {1369, 1369, 85}, {1377, 1415, 85}, {1488, 1514, 85}, {1520, 1522, 86}, {1569, 1594, 86}, {1600, 1610, 86}, {1649, 1719, 86}, {1722, 1726, 87}, {1728, 1742, 87}, {1744, 1747, 87}, {1749, 1749, 87}, {1765, 1766, 88}, {2309, 2361, 88}, {2365, 2365, 88}, {2392, 2401, 88}, {2437, 2444, 89}, {2447, 2448, 89}, {2451, 2472, 89}, {2474, 2480, 89}, {2482, 2482, 90}, {2486, 2489, 90}, {2524, 2525, 90}, {2527, 2529, 90}, {2544, 2545, 91}, {2565, 2570, 91}, {2575, 2576, 91}, {2579, 2600, 91}, {2602, 2608, 92}, {2610, 2611, 92}, {2613, 2614, 92}, {2616, 2617, 92}, {2649, 2652, 93}, {2654, 2654, 93}, {2674, 2676, 93}, {2693, 2699, 93}, {2701, 2701, 94}, {2703, 2705, 94}, {2707, 2728, 94}, {2730, 2736, 94}, {2738, 2739, 95}, {2741, 2745, 95}, {2749, 2749, 95}, {2784, 2784, 95}, {2821, 2828, 96}, {2831, 2832, 96}, {2835, 2856, 96}, {2858, 2864, 96}, {2866, 2867, 97}, {2870, 2873, 97}, {2877, 2877, 97}, {2908, 2909, 97}, {2911, 2913, 98}, {2949, 2954, 98}, {2958, 2960, 98}, {2962, 2965, 98}, {2969, 2970, 99}, {2972, 2972, 99}, {2974, 2975, 99}, {2979, 2980, 99}, {2984, 2986, 100}, {2990, 2997, 100}, {2999, 3001, 100}, {3077, 3084, 100}, {3086, 3088, 101}, {3090, 3112, 101}, {3114, 3123, 101}, {3125, 3129, 101}, {3168, 3169, 102}, {3205, 3212, 102}, {3214, 3216, 102}, {3218, 3240, 102}, {3242, 3251, 103}, {3253, 3257, 103}, {3294, 3294, 103}, {3296, 3297, 103}, {3333, 3340, 104}, {3342, 3344, 104}, {3346, 3368, 104}, {3370, 3385, 104}, {3424, 3425, 105}, {3585, 3630, 105}, {3632, 3632, 105}, {3634, 3635, 105}, {3648, 3654, 106}, {3713, 3714, 106}, {3716, 3716, 106}, {3719, 3720, 106}, {3722, 3722, 107}, {3725, 3725, 107}, {3732, 3735, 107}, {3737, 3743, 107}, {3745, 3747, 108}, {3749, 3749, 108}, {3751, 3751, 108}, {3754, 3755, 108}, {3757, 3758, 109}, {3760, 3760, 109}, {3762, 3763, 109}, {3773, 3773, 109}, {3776, 3780, 110}, {3782, 3782, 110}, {3804, 3805, 110}, {3904, 3911, 110}, {3913, 3945, 111}, {4256, 4293, 111}, {4304, 4342, 111}, {4352, 4441, 111}, {4447, 4514, 112}, {4520, 4601, 112}, {7680, 7835, 112}, {7840, 7929, 112}, {7936, 7957, 113}, {7960, 7965, 113}, {7968, 8005, 113}, {8008, 8013, 113}, {8016, 8023, 114}, {8025, 8025, 114}, {8027, 8027, 114}, {8029, 8029, 114}, {8031, 8061, 115}, {8064, 8116, 115}, {8118, 8124, 115}, {8126, 8126, 115}, {8130, 8132, 116}, {8134, 8140, 116}, {8144, 8147, 116}, {8150, 8155, 116}, {8160, 8172, 117}, {8178, 8180, 117}, {8182, 8188, 117}, {8319, 8319, 117}, {8450, 8450, 118}, {8455, 8455, 118}, {8458, 8467, 118}, {8469, 8469, 118}, {8472, 8477, 119}, {8484, 8484, 119}, {8486, 8486, 119}, {8488, 8488, 119}, {8490, 8497, 120}, {8499, 8504, 120}, {12293, 12293, 120}, {12337, 12341, 120}, {12353, 12436, 121}, {12443, 12446, 121}, {12449, 12538, 121}, {12540, 12542, 121}, {12549, 12588, 122}, {12593, 12686, 122}, {19968, 40869, 122}, {44032, 55203, 122}, {63744, 64045, 123}, {64256, 64262, 123}, {64275, 64279, 123}, {64287, 64296, 123}, {64298, 64310, 124}, {64312, 64316, 124}, {64318, 64318, 124}, {64320, 64321, 124}, {64323, 64324, 125}, {64326, 64433, 125}, {64467, 64829, 125}, {64848, 64911, 125}, {64914, 64967, 126}, {65008, 65019, 126}, {65136, 65138, 126}, {65140, 65140, 126}, {65142, 65276, 127}, {65313, 65338, 127}, {65345, 65370, 127}, {65382, 65470, 127}, {65474, 65479, 128}, {65482, 65487, 128}, {65490, 65495, 128}, {65498, 65500, 128}, },
            {{33, 96, -8}, {97, 100, 73}, {101, 101, 129}, {102, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 104, 73}, {105, 105, 130}, {106, 122, 73}, {123, 65500, -8}, },
            {{33, 100, -9}, {101, 101, 131}, {102, 65500, -9}, },
            {{33, 96, -8}, {97, 108, 73}, {109, 109, 132}, {110, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 97, 133}, {98, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 97, 134}, {98, 113, 73}, {114, 114, 135}, {115, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 120, 73}, {121, 121, 136}, {122, 122, 73}, {123, 65500, -8}, },
            {{48, 57, 137}, {65, 90, 75}, {95, 95, 138}, {97, 122, 75}, {170, 186, -8}, {192, 214, 76}, {216, 246, 76}, {248, 501, 76}, {506, 65500, -8}, },
            {{48, 65500, -16}, },
            {{33, 65500, -8}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{0, 65535, -6}, },
            {},
            {{0, 9, 139}, {11, 12, 139}, {14, 65535, 139}, },
            {},
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{33, 65500, -8}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{33, 96, -8}, {97, 114, 73}, {115, 115, 140}, {116, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 107, 73}, {108, 108, 141}, {109, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 109, 73}, {110, 110, 142}, {111, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 111, 73}, {112, 112, 143}, {113, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 97, 73}, {98, 98, 144}, {99, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 98, 73}, {99, 99, 145}, {100, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 97, 146}, {98, 65500, -13}, },
            {{33, 108, -12}, {109, 109, 147}, {110, 65500, -12}, },
            {{48, 65500, -16}, },
            {{48, 65500, -16}, },
            {{0, 65535, -6}, },
            {{33, 98, -136}, {99, 99, 148}, {100, 65500, -136}, },
            {{33, 100, -9}, {101, 101, 149}, {102, 65500, -9}, },
            {{33, 100, -9}, {101, 101, 150}, {102, 65500, -9}, },
            {{33, 96, -8}, {97, 110, 73}, {111, 111, 151}, {112, 122, 73}, {123, 65500, -8}, },
            {{33, 100, -9}, {101, 101, 152}, {102, 65500, -9}, },
            {{33, 96, -8}, {97, 106, 73}, {107, 107, 153}, {108, 122, 73}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 102, 73}, {103, 103, 154}, {104, 122, 73}, {123, 65500, -8}, },
            {{33, 97, -135}, {98, 98, 155}, {99, 65500, -135}, },
            {{33, 96, -8}, {97, 113, 73}, {114, 114, 156}, {115, 65500, -14}, },
            {{33, 65500, -8}, },
            {{33, 113, -150}, {114, 114, 157}, {115, 65500, -14}, },
            {{33, 113, -150}, {114, 114, 158}, {115, 65500, -14}, },
            {{33, 107, -132}, {108, 108, 159}, {109, 65500, -132}, },
            {{33, 96, -8}, {97, 97, 160}, {98, 65500, -13}, },
            {{33, 108, -12}, {109, 109, 161}, {110, 65500, -12}, },
            {{33, 110, -145}, {111, 111, 162}, {112, 65500, -145}, },
            {{33, 104, -10}, {105, 105, 163}, {106, 65500, -10}, },
            {{33, 96, -8}, {97, 97, 164}, {98, 65500, -13}, },
            {{33, 96, -8}, {97, 115, 73}, {116, 116, 165}, {117, 122, 73}, {123, 65500, -8}, },
            {{33, 65500, -8}, },
            {{33, 102, -148}, {103, 103, 166}, {104, 65500, -148}, },
            {{33, 96, -8}, {97, 97, 167}, {98, 65500, -13}, },
            {{33, 107, -132}, {108, 108, 168}, {109, 65500, -132}, },
            {{33, 111, -134}, {112, 112, 169}, {113, 65500, -134}, },
            {{33, 115, -160}, {116, 116, 170}, {117, 65500, -160}, },
            {{33, 41, -5}, {43, 44, 3}, {45, 45, 171}, {46, 47, 3}, {48, 94, -8}, {95, 95, 172}, {96, 65500, -8}, },
            {{33, 100, -9}, {101, 101, 173}, {102, 65500, -9}, },
            {{33, 65500, -8}, },
            {{33, 104, -10}, {105, 105, 174}, {106, 65500, -10}, },
            {{33, 115, -160}, {116, 116, 175}, {117, 65500, -160}, },
            {{33, 100, -9}, {101, 101, 176}, {102, 65500, -9}, },
            {{33, 41, -5}, {43, 111, 3}, {112, 112, 177}, {113, 126, 3}, {191, 254, 3}, },
            {{33, 111, -134}, {112, 112, 178}, {113, 65500, -134}, },
            {{33, 65500, -8}, },
            {{33, 98, -136}, {99, 99, 179}, {100, 65500, -136}, },
            {{33, 104, -10}, {105, 105, 180}, {106, 65500, -10}, },
            {{33, 96, -8}, {97, 99, 73}, {100, 100, 181}, {101, 122, 73}, {123, 65500, -8}, },
            {{33, 41, -5}, {43, 96, 3}, {97, 97, 182}, {98, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 97, 183}, {98, 65500, -13}, },
            {{33, 65500, -8}, },
            {{33, 110, -145}, {111, 111, 184}, {112, 65500, -145}, },
            {{33, 65500, -8}, },
            {{33, 41, -5}, {43, 98, 3}, {99, 99, 185}, {100, 126, 3}, {191, 254, 3}, },
            {{33, 98, -136}, {99, 99, 186}, {100, 65500, -136}, },
            {{33, 109, -133}, {110, 110, 187}, {111, 65500, -133}, },
            {{33, 41, -5}, {43, 106, 3}, {107, 107, 188}, {108, 126, 3}, {191, 254, 3}, },
            {{33, 106, -147}, {107, 107, 189}, {108, 65500, -147}, },
            {{33, 65500, -8}, },
            {{33, 96, -179}, {97, 97, 190}, {98, 254, -179}, },
            {{33, 96, -8}, {97, 97, 191}, {98, 65500, -13}, },
            {{33, 41, -5}, {43, 102, 3}, {103, 103, 192}, {104, 126, 3}, {191, 254, 3}, },
            {{33, 102, -148}, {103, 103, 193}, {104, 65500, -148}, },
            {{33, 41, -5}, {43, 100, 3}, {101, 101, 194}, {102, 126, 3}, {191, 254, 3}, },
            {{33, 100, -9}, {101, 101, 195}, {102, 65500, -9}, },
            {{33, 254, -5}, },
            {{33, 65500, -8}, },
        }
        { // DESCRIPTION
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 31, 1}, {32, 32, 2}, {33, 41, 1}, {42, 42, 4}, {43, 46, 1}, {47, 47, 5}, {48, 159, 1}, {160, 160, 2}, {161, 8231, 1}, {8232, 8233, 2}, {8234, 65535, 1}, },
            {{0, 41, 1}, {43, 46, 1}, {48, 65535, 1}, },
            {{0, 9, -2}, {10, 31, 1}, {32, 41, -2}, {43, 46, 1}, {48, 65535, -2}, },
            {{0, 65535, -3}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // PRAGMA_CONTENT
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 2}, {32, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 41, 3}, {42, 42, 5}, {43, 64, 3}, {65, 90, 6}, {91, 96, 3}, {97, 122, 6}, {123, 126, 3}, {160, 160, 1}, {170, 170, 7}, {181, 181, 7}, {186, 186, 8}, {191, 191, 3}, {192, 214, 9}, {215, 215, 3}, {216, 246, 9}, {247, 247, 3}, {248, 254, 9}, {255, 501, 8}, {506, 535, 10}, {592, 680, 10}, {688, 696, 10}, {699, 705, 10}, {720, 721, 11}, {736, 740, 11}, {890, 890, 11}, {902, 902, 11}, {904, 906, 12}, {908, 908, 12}, {910, 929, 12}, {931, 974, 12}, {976, 982, 13}, {986, 986, 13}, {988, 988, 13}, {990, 990, 13}, {992, 992, 14}, {994, 1011, 14}, {1025, 1036, 14}, {1038, 1103, 14}, {1105, 1116, 15}, {1118, 1153, 15}, {1168, 1220, 15}, {1223, 1224, 15}, {1227, 1228, 16}, {1232, 1259, 16}, {1262, 1269, 16}, {1272, 1273, 16}, {1329, 1366, 17}, {1369, 1369, 17}, {1377, 1415, 17}, {1488, 1514, 17}, {1520, 1522, 18}, {1569, 1594, 18}, {1600, 1610, 18}, {1649, 1719, 18}, {1722, 1726, 19}, {1728, 1742, 19}, {1744, 1747, 19}, {1749, 1749, 19}, {1765, 1766, 20}, {2309, 2361, 20}, {2365, 2365, 20}, {2392, 2401, 20}, {2437, 2444, 21}, {2447, 2448, 21}, {2451, 2472, 21}, {2474, 2480, 21}, {2482, 2482, 22}, {2486, 2489, 22}, {2524, 2525, 22}, {2527, 2529, 22}, {2544, 2545, 23}, {2565, 2570, 23}, {2575, 2576, 23}, {2579, 2600, 23}, {2602, 2608, 24}, {2610, 2611, 24}, {2613, 2614, 24}, {2616, 2617, 24}, {2649, 2652, 25}, {2654, 2654, 25}, {2674, 2676, 25}, {2693, 2699, 25}, {2701, 2701, 26}, {2703, 2705, 26}, {2707, 2728, 26}, {2730, 2736, 26}, {2738, 2739, 27}, {2741, 2745, 27}, {2749, 2749, 27}, {2784, 2784, 27}, {2821, 2828, 28}, {2831, 2832, 28}, {2835, 2856, 28}, {2858, 2864, 28}, {2866, 2867, 29}, {2870, 2873, 29}, {2877, 2877, 29}, {2908, 2909, 29}, {2911, 2913, 30}, {2949, 2954, 30}, {2958, 2960, 30}, {2962, 2965, 30}, {2969, 2970, 31}, {2972, 2972, 31}, {2974, 2975, 31}, {2979, 2980, 31}, {2984, 2986, 32}, {2990, 2997, 32}, {2999, 3001, 32}, {3077, 3084, 32}, {3086, 3088, 33}, {3090, 3112, 33}, {3114, 3123, 33}, {3125, 3129, 33}, {3168, 3169, 34}, {3205, 3212, 34}, {3214, 3216, 34}, {3218, 3240, 34}, {3242, 3251, 35}, {3253, 3257, 35}, {3294, 3294, 35}, {3296, 3297, 35}, {3333, 3340, 36}, {3342, 3344, 36}, {3346, 3368, 36}, {3370, 3385, 36}, {3424, 3425, 37}, {3585, 3630, 37}, {3632, 3632, 37}, {3634, 3635, 37}, {3648, 3654, 38}, {3713, 3714, 38}, {3716, 3716, 38}, {3719, 3720, 38}, {3722, 3722, 39}, {3725, 3725, 39}, {3732, 3735, 39}, {3737, 3743, 39}, {3745, 3747, 40}, {3749, 3749, 40}, {3751, 3751, 40}, {3754, 3755, 40}, {3757, 3758, 41}, {3760, 3760, 41}, {3762, 3763, 41}, {3773, 3773, 41}, {3776, 3780, 42}, {3782, 3782, 42}, {3804, 3805, 42}, {3904, 3911, 42}, {3913, 3945, 43}, {4256, 4293, 43}, {4304, 4342, 43}, {4352, 4441, 43}, {4447, 4514, 44}, {4520, 4601, 44}, {7680, 7835, 44}, {7840, 7929, 44}, {7936, 7957, 45}, {7960, 7965, 45}, {7968, 8005, 45}, {8008, 8013, 45}, {8016, 8023, 46}, {8025, 8025, 46}, {8027, 8027, 46}, {8029, 8029, 46}, {8031, 8061, 47}, {8064, 8116, 47}, {8118, 8124, 47}, {8126, 8126, 47}, {8130, 8132, 48}, {8134, 8140, 48}, {8144, 8147, 48}, {8150, 8155, 48}, {8160, 8172, 49}, {8178, 8180, 49}, {8182, 8188, 49}, {8232, 8233, 1}, {8319, 8319, 49}, {8450, 8450, 50}, {8455, 8455, 50}, {8458, 8467, 50}, {8469, 8469, 50}, {8472, 8477, 51}, {8484, 8484, 51}, {8486, 8486, 51}, {8488, 8488, 51}, {8490, 8497, 52}, {8499, 8504, 52}, {12293, 12293, 52}, {12337, 12341, 52}, {12353, 12436, 53}, {12443, 12446, 53}, {12449, 12538, 53}, {12540, 12542, 53}, {12549, 12588, 54}, {12593, 12686, 54}, {19968, 40869, 54}, {44032, 55203, 54}, {63744, 64045, 55}, {64256, 64262, 55}, {64275, 64279, 55}, {64287, 64296, 55}, {64298, 64310, 56}, {64312, 64316, 56}, {64318, 64318, 56}, {64320, 64321, 56}, {64323, 64324, 57}, {64326, 64433, 57}, {64467, 64829, 57}, {64848, 64911, 57}, {64914, 64967, 58}, {65008, 65019, 58}, {65136, 65138, 58}, {65140, 65140, 58}, {65142, 65276, 59}, {65313, 65338, 59}, {65345, 65370, 59}, {65382, 65470, 59}, {65474, 65479, 60}, {65482, 65487, 60}, {65490, 65495, 60}, {65498, 65500, 60}, },
            {{9, 9, 1}, {32, 32, 1}, {160, 160, 1}, {8232, 8233, 1}, },
            {},
            {{33, 33, 3}, {35, 41, 3}, {43, 126, 3}, {191, 254, 3}, },
            {{0, 9, 61}, {11, 12, 61}, {14, 33, 61}, {34, 34, 62}, {35, 91, 61}, {92, 92, 63}, {93, 65535, 61}, },
            {{47, 47, 64}, },
            {{33, 41, -5}, {43, 47, 3}, {48, 57, 65}, {58, 64, 3}, {65, 90, 66}, {91, 94, 3}, {95, 95, 67}, {96, 96, 3}, {97, 122, 66}, {123, 126, 3}, {170, 170, 68}, {181, 181, 68}, {186, 186, 69}, {191, 191, 3}, {192, 214, 70}, {215, 215, 3}, {216, 246, 70}, {247, 247, 3}, {248, 254, 70}, {255, 501, 69}, {506, 535, 71}, {592, 680, 71}, {688, 696, 71}, {699, 705, 71}, {720, 721, 72}, {736, 740, 72}, {890, 890, 72}, {902, 902, 72}, {904, 906, 73}, {908, 908, 73}, {910, 929, 73}, {931, 974, 73}, {976, 982, 74}, {986, 986, 74}, {988, 988, 74}, {990, 990, 74}, {992, 992, 75}, {994, 1011, 75}, {1025, 1036, 75}, {1038, 1103, 75}, {1105, 1116, 76}, {1118, 1153, 76}, {1168, 1220, 76}, {1223, 1224, 76}, {1227, 1228, 77}, {1232, 1259, 77}, {1262, 1269, 77}, {1272, 1273, 77}, {1329, 1366, 78}, {1369, 1369, 78}, {1377, 1415, 78}, {1488, 1514, 78}, {1520, 1522, 79}, {1569, 1594, 79}, {1600, 1610, 79}, {1649, 1719, 79}, {1722, 1726, 80}, {1728, 1742, 80}, {1744, 1747, 80}, {1749, 1749, 80}, {1765, 1766, 81}, {2309, 2361, 81}, {2365, 2365, 81}, {2392, 2401, 81}, {2437, 2444, 82}, {2447, 2448, 82}, {2451, 2472, 82}, {2474, 2480, 82}, {2482, 2482, 83}, {2486, 2489, 83}, {2524, 2525, 83}, {2527, 2529, 83}, {2544, 2545, 84}, {2565, 2570, 84}, {2575, 2576, 84}, {2579, 2600, 84}, {2602, 2608, 85}, {2610, 2611, 85}, {2613, 2614, 85}, {2616, 2617, 85}, {2649, 2652, 86}, {2654, 2654, 86}, {2674, 2676, 86}, {2693, 2699, 86}, {2701, 2701, 87}, {2703, 2705, 87}, {2707, 2728, 87}, {2730, 2736, 87}, {2738, 2739, 88}, {2741, 2745, 88}, {2749, 2749, 88}, {2784, 2784, 88}, {2821, 2828, 89}, {2831, 2832, 89}, {2835, 2856, 89}, {2858, 2864, 89}, {2866, 2867, 90}, {2870, 2873, 90}, {2877, 2877, 90}, {2908, 2909, 90}, {2911, 2913, 91}, {2949, 2954, 91}, {2958, 2960, 91}, {2962, 2965, 91}, {2969, 2970, 92}, {2972, 2972, 92}, {2974, 2975, 92}, {2979, 2980, 92}, {2984, 2986, 93}, {2990, 2997, 93}, {2999, 3001, 93}, {3077, 3084, 93}, {3086, 3088, 94}, {3090, 3112, 94}, {3114, 3123, 94}, {3125, 3129, 94}, {3168, 3169, 95}, {3205, 3212, 95}, {3214, 3216, 95}, {3218, 3240, 95}, {3242, 3251, 96}, {3253, 3257, 96}, {3294, 3294, 96}, {3296, 3297, 96}, {3333, 3340, 97}, {3342, 3344, 97}, {3346, 3368, 97}, {3370, 3385, 97}, {3424, 3425, 98}, {3585, 3630, 98}, {3632, 3632, 98}, {3634, 3635, 98}, {3648, 3654, 99}, {3713, 3714, 99}, {3716, 3716, 99}, {3719, 3720, 99}, {3722, 3722, 100}, {3725, 3725, 100}, {3732, 3735, 100}, {3737, 3743, 100}, {3745, 3747, 101}, {3749, 3749, 101}, {3751, 3751, 101}, {3754, 3755, 101}, {3757, 3758, 102}, {3760, 3760, 102}, {3762, 3763, 102}, {3773, 3773, 102}, {3776, 3780, 103}, {3782, 3782, 103}, {3804, 3805, 103}, {3904, 3911, 103}, {3913, 3945, 104}, {4256, 4293, 104}, {4304, 4342, 104}, {4352, 4441, 104}, {4447, 4514, 105}, {4520, 4601, 105}, {7680, 7835, 105}, {7840, 7929, 105}, {7936, 7957, 106}, {7960, 7965, 106}, {7968, 8005, 106}, {8008, 8013, 106}, {8016, 8023, 107}, {8025, 8025, 107}, {8027, 8027, 107}, {8029, 8029, 107}, {8031, 8061, 108}, {8064, 8116, 108}, {8118, 8124, 108}, {8126, 8126, 108}, {8130, 8132, 109}, {8134, 8140, 109}, {8144, 8147, 109}, {8150, 8155, 109}, {8160, 8172, 110}, {8178, 8180, 110}, {8182, 8188, 110}, {8319, 8319, 110}, {8450, 8450, 111}, {8455, 8455, 111}, {8458, 8467, 111}, {8469, 8469, 111}, {8472, 8477, 112}, {8484, 8484, 112}, {8486, 8486, 112}, {8488, 8488, 112}, {8490, 8497, 113}, {8499, 8504, 113}, {12293, 12293, 113}, {12337, 12341, 113}, {12353, 12436, 114}, {12443, 12446, 114}, {12449, 12538, 114}, {12540, 12542, 114}, {12549, 12588, 115}, {12593, 12686, 115}, {19968, 40869, 115}, {44032, 55203, 115}, {63744, 64045, 116}, {64256, 64262, 116}, {64275, 64279, 116}, {64287, 64296, 116}, {64298, 64310, 117}, {64312, 64316, 117}, {64318, 64318, 117}, {64320, 64321, 117}, {64323, 64324, 118}, {64326, 64433, 118}, {64467, 64829, 118}, {64848, 64911, 118}, {64914, 64967, 119}, {65008, 65019, 119}, {65136, 65138, 119}, {65140, 65140, 119}, {65142, 65276, 120}, {65313, 65338, 120}, {65345, 65370, 120}, {65382, 65470, 120}, {65474, 65479, 121}, {65482, 65487, 121}, {65490, 65495, 121}, {65498, 65500, 121}, },
            {{48, 57, 122}, {65, 90, 68}, {95, 95, 123}, {97, 122, 68}, {170, 186, -8}, {192, 214, 69}, {216, 246, 69}, {248, 501, 69}, {506, 65500, -8}, },
            {{48, 65500, -9}, },
            {{33, 65500, -8}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{0, 65535, -6}, },
            {},
            {{0, 9, 124}, {11, 12, 124}, {14, 65535, 124}, },
            {},
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{33, 65500, -8}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{48, 65500, -9}, },
            {{0, 65535, -6}, },
        }
        { // PRAGMA_PACKAGE_CONTENT
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 2}, {32, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 41, 3}, {42, 42, 5}, {43, 64, 3}, {65, 90, 6}, {91, 96, 3}, {97, 104, 6}, {105, 105, 7}, {106, 122, 6}, {123, 126, 3}, {160, 160, 1}, {170, 170, 8}, {181, 181, 8}, {186, 186, 9}, {191, 191, 3}, {192, 214, 10}, {215, 215, 3}, {216, 246, 10}, {247, 247, 3}, {248, 254, 10}, {255, 501, 9}, {506, 535, 11}, {592, 680, 11}, {688, 696, 11}, {699, 705, 11}, {720, 721, 12}, {736, 740, 12}, {890, 890, 12}, {902, 902, 12}, {904, 906, 13}, {908, 908, 13}, {910, 929, 13}, {931, 974, 13}, {976, 982, 14}, {986, 986, 14}, {988, 988, 14}, {990, 990, 14}, {992, 992, 15}, {994, 1011, 15}, {1025, 1036, 15}, {1038, 1103, 15}, {1105, 1116, 16}, {1118, 1153, 16}, {1168, 1220, 16}, {1223, 1224, 16}, {1227, 1228, 17}, {1232, 1259, 17}, {1262, 1269, 17}, {1272, 1273, 17}, {1329, 1366, 18}, {1369, 1369, 18}, {1377, 1415, 18}, {1488, 1514, 18}, {1520, 1522, 19}, {1569, 1594, 19}, {1600, 1610, 19}, {1649, 1719, 19}, {1722, 1726, 20}, {1728, 1742, 20}, {1744, 1747, 20}, {1749, 1749, 20}, {1765, 1766, 21}, {2309, 2361, 21}, {2365, 2365, 21}, {2392, 2401, 21}, {2437, 2444, 22}, {2447, 2448, 22}, {2451, 2472, 22}, {2474, 2480, 22}, {2482, 2482, 23}, {2486, 2489, 23}, {2524, 2525, 23}, {2527, 2529, 23}, {2544, 2545, 24}, {2565, 2570, 24}, {2575, 2576, 24}, {2579, 2600, 24}, {2602, 2608, 25}, {2610, 2611, 25}, {2613, 2614, 25}, {2616, 2617, 25}, {2649, 2652, 26}, {2654, 2654, 26}, {2674, 2676, 26}, {2693, 2699, 26}, {2701, 2701, 27}, {2703, 2705, 27}, {2707, 2728, 27}, {2730, 2736, 27}, {2738, 2739, 28}, {2741, 2745, 28}, {2749, 2749, 28}, {2784, 2784, 28}, {2821, 2828, 29}, {2831, 2832, 29}, {2835, 2856, 29}, {2858, 2864, 29}, {2866, 2867, 30}, {2870, 2873, 30}, {2877, 2877, 30}, {2908, 2909, 30}, {2911, 2913, 31}, {2949, 2954, 31}, {2958, 2960, 31}, {2962, 2965, 31}, {2969, 2970, 32}, {2972, 2972, 32}, {2974, 2975, 32}, {2979, 2980, 32}, {2984, 2986, 33}, {2990, 2997, 33}, {2999, 3001, 33}, {3077, 3084, 33}, {3086, 3088, 34}, {3090, 3112, 34}, {3114, 3123, 34}, {3125, 3129, 34}, {3168, 3169, 35}, {3205, 3212, 35}, {3214, 3216, 35}, {3218, 3240, 35}, {3242, 3251, 36}, {3253, 3257, 36}, {3294, 3294, 36}, {3296, 3297, 36}, {3333, 3340, 37}, {3342, 3344, 37}, {3346, 3368, 37}, {3370, 3385, 37}, {3424, 3425, 38}, {3585, 3630, 38}, {3632, 3632, 38}, {3634, 3635, 38}, {3648, 3654, 39}, {3713, 3714, 39}, {3716, 3716, 39}, {3719, 3720, 39}, {3722, 3722, 40}, {3725, 3725, 40}, {3732, 3735, 40}, {3737, 3743, 40}, {3745, 3747, 41}, {3749, 3749, 41}, {3751, 3751, 41}, {3754, 3755, 41}, {3757, 3758, 42}, {3760, 3760, 42}, {3762, 3763, 42}, {3773, 3773, 42}, {3776, 3780, 43}, {3782, 3782, 43}, {3804, 3805, 43}, {3904, 3911, 43}, {3913, 3945, 44}, {4256, 4293, 44}, {4304, 4342, 44}, {4352, 4441, 44}, {4447, 4514, 45}, {4520, 4601, 45}, {7680, 7835, 45}, {7840, 7929, 45}, {7936, 7957, 46}, {7960, 7965, 46}, {7968, 8005, 46}, {8008, 8013, 46}, {8016, 8023, 47}, {8025, 8025, 47}, {8027, 8027, 47}, {8029, 8029, 47}, {8031, 8061, 48}, {8064, 8116, 48}, {8118, 8124, 48}, {8126, 8126, 48}, {8130, 8132, 49}, {8134, 8140, 49}, {8144, 8147, 49}, {8150, 8155, 49}, {8160, 8172, 50}, {8178, 8180, 50}, {8182, 8188, 50}, {8232, 8233, 1}, {8319, 8319, 50}, {8450, 8450, 51}, {8455, 8455, 51}, {8458, 8467, 51}, {8469, 8469, 51}, {8472, 8477, 52}, {8484, 8484, 52}, {8486, 8486, 52}, {8488, 8488, 52}, {8490, 8497, 53}, {8499, 8504, 53}, {12293, 12293, 53}, {12337, 12341, 53}, {12353, 12436, 54}, {12443, 12446, 54}, {12449, 12538, 54}, {12540, 12542, 54}, {12549, 12588, 55}, {12593, 12686, 55}, {19968, 40869, 55}, {44032, 55203, 55}, {63744, 64045, 56}, {64256, 64262, 56}, {64275, 64279, 56}, {64287, 64296, 56}, {64298, 64310, 57}, {64312, 64316, 57}, {64318, 64318, 57}, {64320, 64321, 57}, {64323, 64324, 58}, {64326, 64433, 58}, {64467, 64829, 58}, {64848, 64911, 58}, {64914, 64967, 59}, {65008, 65019, 59}, {65136, 65138, 59}, {65140, 65140, 59}, {65142, 65276, 60}, {65313, 65338, 60}, {65345, 65370, 60}, {65382, 65470, 60}, {65474, 65479, 61}, {65482, 65487, 61}, {65490, 65495, 61}, {65498, 65500, 61}, },
            {{9, 9, 1}, {32, 32, 1}, {160, 160, 1}, {8232, 8233, 1}, },
            {},
            {{33, 33, 3}, {35, 41, 3}, {43, 126, 3}, {191, 254, 3}, },
            {{0, 9, 62}, {11, 12, 62}, {14, 33, 62}, {34, 34, 63}, {35, 91, 62}, {92, 92, 64}, {93, 65535, 62}, },
            {{47, 47, 65}, },
            {{33, 41, -5}, {43, 47, 3}, {48, 57, 66}, {58, 64, 3}, {65, 90, 67}, {91, 94, 3}, {95, 95, 68}, {96, 96, 3}, {97, 122, 67}, {123, 126, 3}, {170, 170, 69}, {181, 181, 69}, {186, 186, 70}, {191, 191, 3}, {192, 214, 71}, {215, 215, 3}, {216, 246, 71}, {247, 247, 3}, {248, 254, 71}, {255, 501, 70}, {506, 535, 72}, {592, 680, 72}, {688, 696, 72}, {699, 705, 72}, {720, 721, 73}, {736, 740, 73}, {890, 890, 73}, {902, 902, 73}, {904, 906, 74}, {908, 908, 74}, {910, 929, 74}, {931, 974, 74}, {976, 982, 75}, {986, 986, 75}, {988, 988, 75}, {990, 990, 75}, {992, 992, 76}, {994, 1011, 76}, {1025, 1036, 76}, {1038, 1103, 76}, {1105, 1116, 77}, {1118, 1153, 77}, {1168, 1220, 77}, {1223, 1224, 77}, {1227, 1228, 78}, {1232, 1259, 78}, {1262, 1269, 78}, {1272, 1273, 78}, {1329, 1366, 79}, {1369, 1369, 79}, {1377, 1415, 79}, {1488, 1514, 79}, {1520, 1522, 80}, {1569, 1594, 80}, {1600, 1610, 80}, {1649, 1719, 80}, {1722, 1726, 81}, {1728, 1742, 81}, {1744, 1747, 81}, {1749, 1749, 81}, {1765, 1766, 82}, {2309, 2361, 82}, {2365, 2365, 82}, {2392, 2401, 82}, {2437, 2444, 83}, {2447, 2448, 83}, {2451, 2472, 83}, {2474, 2480, 83}, {2482, 2482, 84}, {2486, 2489, 84}, {2524, 2525, 84}, {2527, 2529, 84}, {2544, 2545, 85}, {2565, 2570, 85}, {2575, 2576, 85}, {2579, 2600, 85}, {2602, 2608, 86}, {2610, 2611, 86}, {2613, 2614, 86}, {2616, 2617, 86}, {2649, 2652, 87}, {2654, 2654, 87}, {2674, 2676, 87}, {2693, 2699, 87}, {2701, 2701, 88}, {2703, 2705, 88}, {2707, 2728, 88}, {2730, 2736, 88}, {2738, 2739, 89}, {2741, 2745, 89}, {2749, 2749, 89}, {2784, 2784, 89}, {2821, 2828, 90}, {2831, 2832, 90}, {2835, 2856, 90}, {2858, 2864, 90}, {2866, 2867, 91}, {2870, 2873, 91}, {2877, 2877, 91}, {2908, 2909, 91}, {2911, 2913, 92}, {2949, 2954, 92}, {2958, 2960, 92}, {2962, 2965, 92}, {2969, 2970, 93}, {2972, 2972, 93}, {2974, 2975, 93}, {2979, 2980, 93}, {2984, 2986, 94}, {2990, 2997, 94}, {2999, 3001, 94}, {3077, 3084, 94}, {3086, 3088, 95}, {3090, 3112, 95}, {3114, 3123, 95}, {3125, 3129, 95}, {3168, 3169, 96}, {3205, 3212, 96}, {3214, 3216, 96}, {3218, 3240, 96}, {3242, 3251, 97}, {3253, 3257, 97}, {3294, 3294, 97}, {3296, 3297, 97}, {3333, 3340, 98}, {3342, 3344, 98}, {3346, 3368, 98}, {3370, 3385, 98}, {3424, 3425, 99}, {3585, 3630, 99}, {3632, 3632, 99}, {3634, 3635, 99}, {3648, 3654, 100}, {3713, 3714, 100}, {3716, 3716, 100}, {3719, 3720, 100}, {3722, 3722, 101}, {3725, 3725, 101}, {3732, 3735, 101}, {3737, 3743, 101}, {3745, 3747, 102}, {3749, 3749, 102}, {3751, 3751, 102}, {3754, 3755, 102}, {3757, 3758, 103}, {3760, 3760, 103}, {3762, 3763, 103}, {3773, 3773, 103}, {3776, 3780, 104}, {3782, 3782, 104}, {3804, 3805, 104}, {3904, 3911, 104}, {3913, 3945, 105}, {4256, 4293, 105}, {4304, 4342, 105}, {4352, 4441, 105}, {4447, 4514, 106}, {4520, 4601, 106}, {7680, 7835, 106}, {7840, 7929, 106}, {7936, 7957, 107}, {7960, 7965, 107}, {7968, 8005, 107}, {8008, 8013, 107}, {8016, 8023, 108}, {8025, 8025, 108}, {8027, 8027, 108}, {8029, 8029, 108}, {8031, 8061, 109}, {8064, 8116, 109}, {8118, 8124, 109}, {8126, 8126, 109}, {8130, 8132, 110}, {8134, 8140, 110}, {8144, 8147, 110}, {8150, 8155, 110}, {8160, 8172, 111}, {8178, 8180, 111}, {8182, 8188, 111}, {8319, 8319, 111}, {8450, 8450, 112}, {8455, 8455, 112}, {8458, 8467, 112}, {8469, 8469, 112}, {8472, 8477, 113}, {8484, 8484, 113}, {8486, 8486, 113}, {8488, 8488, 113}, {8490, 8497, 114}, {8499, 8504, 114}, {12293, 12293, 114}, {12337, 12341, 114}, {12353, 12436, 115}, {12443, 12446, 115}, {12449, 12538, 115}, {12540, 12542, 115}, {12549, 12588, 116}, {12593, 12686, 116}, {19968, 40869, 116}, {44032, 55203, 116}, {63744, 64045, 117}, {64256, 64262, 117}, {64275, 64279, 117}, {64287, 64296, 117}, {64298, 64310, 118}, {64312, 64316, 118}, {64318, 64318, 118}, {64320, 64321, 118}, {64323, 64324, 119}, {64326, 64433, 119}, {64467, 64829, 119}, {64848, 64911, 119}, {64914, 64967, 120}, {65008, 65019, 120}, {65136, 65138, 120}, {65140, 65140, 120}, {65142, 65276, 121}, {65313, 65338, 121}, {65345, 65370, 121}, {65382, 65470, 121}, {65474, 65479, 122}, {65482, 65487, 122}, {65490, 65495, 122}, {65498, 65500, 122}, },
            {{33, 96, -8}, {97, 108, 67}, {109, 109, 123}, {110, 122, 67}, {123, 65500, -8}, },
            {{48, 57, 124}, {65, 90, 69}, {95, 95, 125}, {97, 122, 69}, {170, 186, -8}, {192, 214, 70}, {216, 246, 70}, {248, 501, 70}, {506, 65500, -8}, },
            {{48, 65500, -10}, },
            {{33, 65500, -8}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{0, 65535, -6}, },
            {},
            {{0, 9, 126}, {11, 12, 126}, {14, 65535, 126}, },
            {},
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{33, 65500, -8}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{33, 65500, -8}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{33, 96, -8}, {97, 111, 67}, {112, 112, 127}, {113, 122, 67}, {123, 65500, -8}, },
            {{48, 65500, -10}, },
            {{48, 65500, -10}, },
            {{0, 65535, -6}, },
            {{33, 96, -8}, {97, 110, 67}, {111, 111, 128}, {112, 122, 67}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 113, 67}, {114, 114, 129}, {115, 122, 67}, {123, 65500, -8}, },
            {{33, 96, -8}, {97, 115, 67}, {116, 116, 130}, {117, 122, 67}, {123, 65500, -8}, },
            {{33, 41, -5}, {43, 44, 3}, {45, 45, 131}, {46, 47, 3}, {48, 94, -8}, {95, 95, 132}, {96, 65500, -8}, },
            {{33, 41, -5}, {43, 111, 3}, {112, 112, 133}, {113, 126, 3}, {191, 254, 3}, },
            {{33, 111, -125}, {112, 112, 134}, {113, 65500, -125}, },
            {{33, 41, -5}, {43, 96, 3}, {97, 97, 135}, {98, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 97, 136}, {98, 122, 67}, {123, 65500, -8}, },
            {{33, 41, -5}, {43, 98, 3}, {99, 99, 137}, {100, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 98, 67}, {99, 99, 138}, {100, 122, 67}, {123, 65500, -8}, },
            {{33, 41, -5}, {43, 106, 3}, {107, 107, 139}, {108, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 106, 67}, {107, 107, 140}, {108, 122, 67}, {123, 65500, -8}, },
            {{33, 96, -135}, {97, 97, 141}, {98, 254, -135}, },
            {{33, 96, -8}, {97, 97, 142}, {98, 65500, -136}, },
            {{33, 41, -5}, {43, 102, 3}, {103, 103, 143}, {104, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 102, 67}, {103, 103, 144}, {104, 122, 67}, {123, 65500, -8}, },
            {{33, 41, -5}, {43, 100, 3}, {101, 101, 145}, {102, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 100, 67}, {101, 101, 146}, {102, 122, 67}, {123, 65500, -8}, },
            {{33, 254, -5}, },
            {{33, 65500, -8}, },
        }
        { // PRAGMA_IGNORE
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 31, 1}, {32, 32, 2}, {33, 41, 1}, {42, 42, 4}, {43, 46, 1}, {47, 47, 5}, {48, 159, 1}, {160, 160, 2}, {161, 8231, 1}, {8232, 8233, 2}, {8234, 65535, 1}, },
            {{0, 41, 1}, {43, 46, 1}, {48, 65535, 1}, },
            {{0, 9, -2}, {10, 31, 1}, {32, 41, -2}, {43, 46, 1}, {48, 65535, -2}, },
            {{0, 65535, -3}, },
            {{47, 47, 6}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // SECTION
        {-1, 265, 265, -1, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 17, 3, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, 4, 3, 3, 258, 258, 258, 258, 258, 258, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 258, 258, 258, 258, 258, 258, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 250, 251, -1, 252, -1, -1, 258, 258, 258, 120, 258, 258, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 258, 258, 258, 258, 121, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 254, -1, 258, 258, 119, 258, -1, -1, -1, -1, -1, -1, -1, 241, 230, 242, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 258, 258, 258, -1, -1, -1, -1, -1, -1, -1, 243, -1, -1, -1, -1, -1, -1, -1, 248, -1, -1, -1, 258, 258, 258, -1, -1, -1, 237, -1, -1, -1, -1, 245, -1, -1, -1, 255, 229, -1, -1, 253, 258, 258, 138, -1, -1, 234, -1, -1, -1, 240, 228, -1, -1, -1, 247, 249, -1, 95, 258, -1, -1, -1, -1, 238, 239, -1, -1, -1, -1, 258, -1, -1, -1, -1, -1, -1, -1, 231, 258, -1, -1, -1, -1, -1, -1, 256, 108, -1, -1, -1, -1, 244, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 246, -1, -1, -1, -1, 232, 233, 235, 236, },
        // NORMAL
        {-1, 265, 265, 26, -1, 27, 28, 29, 30, 31, 32, 33, 34, 36, 39, 40, 44, 46, 262, 262, 54, 57, 58, 70, 73, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 156, 51, 157, 160, 264, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 216, 218, 217, 223, 187, 44, 258, 34, 46, 258, 258, 258, 29, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 45, -1, 258, 126, 258, 132, 114, 258, 63, 53, 41, 159, 61, 42, 75, 220, 72, 68, 37, 62, 43, 26, 27, 215, 54, 47, 131, 143, 40, 218, 219, 30, 188, 52, 158, 223, 50, 67, 79, 65, 49, 64, 48, 78, 257, 88, 115, 147, 60, 160, 222, 221, 66, 69, 38, 74, 77, 66, 222, 258, 258, 224, 225, 226, 60, 258, 258, 258, 258, 258, 258, -1, 25, -1, 0, -1, 35, -1, -1, -1, 43, -1, 45, 17, 3, 47, -1, 50, 52, -1, -1, 55, 56, 55, -1, -1, 60, 62, 64, -1, 67, 59, 69, -1, 71, 72, -1, -1, 78, 79, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 85, 258, 258, 258, 258, 258, 98, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 107, 258, 110, 258, 258, 258, 258, 258, 258, 128, 258, 130, 131, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 158, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 175, 258, 258, 258, 258, 258, 258, 258, 258, 258, 188, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, -1, 221, 219, 223, 127, 127, 133, 133, -1, 22, 37, 41, 4, 3, 3, 48, -1, 53, 263, 63, 61, -1, 65, 66, -1, 68, 74, 75, -1, -1, 258, 82, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 102, 258, 258, 258, 258, 258, 105, 258, 258, 258, 258, 258, 258, 113, 258, 117, 258, 258, 258, 258, 258, 124, 258, 132, 134, 258, 258, 258, 258, 258, 142, 258, 258, 258, 258, 258, 258, 258, 258, 258, 150, 258, 258, 159, 258, 258, 162, 258, 258, 258, 258, 258, 170, 258, 258, 173, 258, 258, 258, 258, 258, 258, 258, 183, 184, 258, 186, 187, 258, 258, 258, 258, 196, 197, 198, 199, 258, 201, 258, 258, 207, 258, 258, 258, 258, 212, 258, 258, 220, 222, 38, 42, 49, 225, 224, 76, 77, -1, -1, 258, 258, 258, 258, 87, 89, 258, 258, 258, 258, 258, 258, 258, 258, 100, 258, 258, 258, 258, 258, 258, 258, 106, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 125, 258, 258, 133, 258, 258, 258, 258, 258, 258, 139, 258, 141, 258, 258, 258, 145, 146, 258, 258, 148, 258, 258, 153, 258, 258, 258, 258, 163, 258, 258, 165, 258, 168, 258, 258, 258, 258, 258, 258, 178, 258, 181, 182, 258, 189, 258, 191, 258, 193, 194, 195, 258, 202, 204, 205, 206, 258, 258, 210, 211, 213, 258, 226, -1, -1, 258, 258, 86, 258, 258, 258, 258, 258, 258, 258, 258, 101, 258, 258, 258, 258, 258, 104, 258, 258, 258, 258, 258, 258, 258, 115, 258, 258, 258, 258, 258, 120, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 143, 258, 258, 147, 258, 258, 154, 155, 161, 258, 164, 257, 258, 169, 258, 172, 174, 176, 177, 179, 258, 258, 258, 258, 200, 203, 258, 258, 214, -1, -1, 258, 83, 90, 258, 258, 258, 258, 258, 258, 258, 258, 99, 258, 129, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 122, 123, 258, 258, 258, 258, 258, 258, 258, 258, 258, 140, 144, 121, 149, 258, 258, 88, 258, 171, 258, 185, 258, 192, 208, 258, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 103, 258, 258, 258, 109, 258, 258, 114, 258, 258, 119, 126, 258, 258, 258, 258, 258, 258, 137, 258, 258, 258, 258, 151, 166, 180, 190, 209, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 111, 258, 258, 258, 127, 258, 258, 135, 258, 258, 258, 258, 258, 258, 258, 167, -1, -1, 258, 258, 258, 258, 93, 258, 258, 258, 258, 258, 258, 227, 258, 258, 258, 116, 258, 258, 258, 258, 258, 258, 258, 258, 258, 152, -1, -1, 258, 258, 84, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, 129, 97, 136, 258, 138, 258, 258, -1, -1, -1, 258, 258, 258, 258, 258, 94, 258, 95, 258, 96, 258, 258, 258, 258, 258, 258, -1, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, -1, -1, -1, 258, 258, 258, 258, 258, 258, 258, 258, 258, 258, -1, -1, -1, 258, 258, 258, 258, 258, 108, 112, 112, 258, -1, -1, -1, 258, 258, 258, 258, 258, -1, -1, -1, 258, 258, 258, 258, 118, -1, -1, -1, 258, 258, 258, 258, -1, -1, -1, 80, 81, 91, 92, 260, -1, -1, 260, 260, -1, -1, -1, -1, 259, 261, 259, 259, 261, 261, },
        // COMMENT
        {19, 19, 19, 19, 20, 21, 18, },
        // MULTILINE_STRING_STATE
        {24, 24, 24, 24, -1, 24, -1, 24, -1, 24, -1, 24, 23, 24, -1, 24, 24, },
        // SHEBANG
        {-1, 2, 2, 1, 2, 265, 0, },
        // PRAGMA
        {-1, 265, 265, 13, -1, -1, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, -1, 13, -1, 5, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, -1, 13, 13, 13, 13, 13, 13, 13, 13, 11, 9, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 11, 13, 13, 13, 13, 13, 10, 13, 13, 13, 13, 13, 7, 13, 6, 13, 13, 13, 13, 13, 11, 13, 13, 13, 13, 13, 13, 12, 12, },
        // DESCRIPTION
        {14, 14, 14, 14, 20, 21, 18, },
        // PRAGMA_CONTENT
        {-1, 265, 265, 15, -1, -1, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, -1, 15, -1, 5, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, -1, },
        // PRAGMA_PACKAGE_CONTENT
        {-1, 265, 265, 15, -1, -1, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, -1, 15, -1, 5, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, -1, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 12, },
        // PRAGMA_IGNORE
        {16, 16, 16, 16, 20, 21, 18, },

    };*/

    public static class State
    {
        public final static State SECTION = new State(0);
        public final static State NORMAL = new State(1);
        public final static State COMMENT = new State(2);
        public final static State MULTILINE_STRING_STATE = new State(3);
        public final static State SHEBANG = new State(4);
        public final static State PRAGMA = new State(5);
        public final static State DESCRIPTION = new State(6);
        public final static State PRAGMA_CONTENT = new State(7);
        public final static State PRAGMA_PACKAGE_CONTENT = new State(8);
        public final static State PRAGMA_IGNORE = new State(9);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
